package{
  import flash.geom.Vector3D;
  import bounds.*;
  import figure.Point3D;

//--------------------------------------------------------------------//
// \iqL̐ϖ@f[^f̒ۃX[p[NX
  public class AbstractFVMDataModel{

// xiq_
    protected var nx:int;

// yiq_
    protected var ny:int;

// ziq_
    protected var nz:int;

// ̃p[^
    protected var param:FlowParameter;

// ޗf[^
    protected var material:Material;

// \iqf[^f
    protected var grid:GridModel;

// ꋫE
    protected var flowBc:BoundaryCondition;

// xx̃Xg
    protected var u:Array;

// xỹXg
    protected var v:Array;

// xz̃Xg
    protected var w:Array;

// ͂̃Xg
    protected var p:Array;

// ͂̃Xg
    protected var p0:Array;

// ϑx̐̃Xg
    protected var uu:Array;

// ϑxŐ̃Xg
    protected var vv:Array;

// ϑxĐ̃Xg
    protected var ww:Array;

// fʃ|C^
    protected var section:Pointer;

//--------------------------------------------------------------------//
// \iqL̐ϖ@f[^f\z
    public function AbstractFVMDataModel(){
      nx=0;
      ny=0;
      nz=0;
      param=new FlowParameter();
      material=new Material(1.0,0.0);
      grid=new GridModel();
      flowBc=new BoundaryCondition();
      section=new Pointer();
    }

//--------------------------------------------------------------------//
// ̃Xebv̌vZ
    public function nextStep():void{
    }

//--------------------------------------------------------------------//
// ̃p[^Ԃ
    public function getFlowParameter():FlowParameter{
      return param;
    }

//--------------------------------------------------------------------//
// ޗf[^Ԃ
    public function getMaterial():Material{
      return material;
    }

//--------------------------------------------------------------------//
// ޗf[^ݒ肷
    public function setMaterial(material:Material):void{
      this.material=material;
    }

//--------------------------------------------------------------------//
// \iqf[^fԂ
    public function getGridModel():GridModel{
      return grid;
    }

//--------------------------------------------------------------------//
// ꋫEԂ
    public function getFlowBC():BoundaryCondition{
      return flowBc;
    }

//--------------------------------------------------------------------//
// Eݒ肷
// flowBc - ꋫE
    public function setBoundaryCondition(flowBc:BoundaryCondition):void{
      this.flowBc=flowBc;
    }

//--------------------------------------------------------------------//
// fʃ|C^Ԃ
    public function getSection():Pointer{
      return section;
    }

//--------------------------------------------------------------------//
// iq_ݒ肷
    public function setGrid():void{
      nx=grid.nx;
      ny=grid.ny;
      nz=grid.nz;
      u=new Array(nx+2);
      v=new Array(nx+1);
      w=new Array(nx+1);
      uu=new Array(nx+2);
      vv=new Array(nx+1);
      ww=new Array(nx+1);
      p=new Array(nx+1);

      for(var i:int=0;i<nx+2;i++){
      	u[i]=new Array(ny+1);
      	uu[i]=new Array(ny+1);
      	for(var j:int=0;j<=ny;j++){
      	  u[i][j]=new Vector.<Number>(nz+1,true);
      	  uu[i][j]=new Vector.<Number>(nz+1,true);
      	  for(var k:int=0;k<=nz;k++){
      	    u[i][j][k]=0.0;
      	  }
      	}
      }

      for(i=0;i<=nx;i++){
      	v[i]=new Array(ny+2);
      	vv[i]=new Array(ny+2);
      	w[i]=new Array(ny+1);
      	ww[i]=new Array(ny+1);
      	p[i]=new Array(ny+1);
      	for(j=0;j<ny+2;j++){
      	  v[i][j]=new Vector.<Number>(nz+1,true);
      	  vv[i][j]=new Vector.<Number>(nz+1,true);
      	  for(k=0;k<=nz;k++){
      	    v[i][j][k]=0.0;
      	  }
      	}
      	for(j=0;j<=ny;j++){
      	  w[i][j]=new Vector.<Number>(nz+2,true);
      	  ww[i][j]=new Vector.<Number>(nz+2,true);
      	  p[i][j]=new Vector.<Number>(nz+1,true);
      	  for(k=0;k<=nz;k++){
      	    w[i][j][k]=0.0;
      	    p[i][j][k]=0.0;
      	  }
      	  w[i][j][nz+1]=0.0;
      	}
      }
      section.set(-1,-1,nz/2);
    }

//--------------------------------------------------------------------//
// 
    public function init():void{
      param.init();
    }

//--------------------------------------------------------------------//
// ϑxvZ
    protected function contraVarVel():void{
      for(var i:int=1;i<=nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    var v0:Number=0.25*(v[i-1][j][k]+v[i-1][j+1][k]
      	      	      	       +v[i][j][k]+v[i][j+1][k]);
      	    var w0:Number=0.25*(w[i-1][j][k]+w[i-1][j][k+1]
      	      	      	       +w[i][j][k]+w[i][j][k+1]);
      	    uu[i][j][k]=grid.transU[i][j][k].contraVx(u[i][j][k],v0,w0);
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<=ny;j++){
      	  for(k=1;k<nz;k++){
      	    var u0:Number=0.25*(u[i][j-1][k]+u[i+1][j-1][k]
      	      	      	       +u[i][j][k]+u[i+1][j][k]);
      	    w0=0.25*(w[i][j-1][k]+w[i][j-1][k+1]
      	      	    +w[i][j][k]+w[i][j][k+1]);
      	    vv[i][j][k]=grid.transV[i][j][k].contraVy(u0,v[i][j][k],w0);
      	  }
      	}
      	for(j=1;j<ny;j++){
      	  for(k=1;k<=nz;k++){
      	    u0=0.25*(u[i][j][k-1]+u[i+1][j][k-1]
      	      	    +u[i][j][k]+u[i+1][j][k]);
      	    v0=0.25*(v[i][j][k-1]+v[i][j+1][k-1]
      	      	    +v[i][j][k]+v[i][j+1][k]);
      	    ww[i][j][k]=grid.transW[i][j][k].contraVz(u0,v0,w[i][j][k]);
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// xxʒu̔ϑxԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    protected function contraAtU(i:int,j:int,k:int):Vector3D{
      var trans:Transform=grid.transU[i][j][k];
      var vp:Number=0.25*(v[i-1][j][k]+v[i-1][j+1][k]
      	      	      	 +v[i][j][k]+v[i][j+1][k]);
      var wp:Number=0.25*(w[i-1][j][k]+w[i-1][j][k+1]
      	      	      	 +w[i][j][k]+w[i][j][k+1]);
      return new Vector3D(trans.contraVx(u[i][j][k],vp,wp),
      	      	      	  trans.contraVy(u[i][j][k],vp,wp),
      	      	      	  trans.contraVz(u[i][j][k],vp,wp),1.0);
    }

//--------------------------------------------------------------------//
// xyʒu̔ϑxԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    protected function contraAtV(i:int,j:int,k:int):Vector3D{
      var trans:Transform=grid.transV[i][j][k];
      var up:Number=0.25*(u[i][j-1][k]+u[i+1][j-1][k]
      	      	      	 +u[i][j][k]+u[i+1][j][k]);
      var wp:Number=0.25*(w[i][j-1][k]+w[i][j-1][k+1]
      	      	      	 +w[i][j][k]+w[i][j][k+1]);
      return new Vector3D(trans.contraVx(up,v[i][j][k],wp),
      	      	      	  trans.contraVy(up,v[i][j][k],wp),
      	      	      	  trans.contraVz(up,v[i][j][k],wp),1.0);
    }

//--------------------------------------------------------------------//
// xzʒu̔ϑxԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    protected function contraAtW(i:int,j:int,k:int):Vector3D{
      var trans:Transform=grid.transW[i][j][k];
      var up:Number=0.25*(u[i][j][k-1]+u[i+1][j][k-1]
      	      	      	 +u[i][j][k]+u[i+1][j][k]);
      var vp:Number=0.25*(v[i][j][k-1]+v[i][j+1][k-1]
      	      	      	 +v[i][j][k]+v[i][j+1][k]);
      return new Vector3D(trans.contraVx(up,vp,w[i][j][k]),
      	      	      	  trans.contraVy(up,vp,w[i][j][k]),
      	      	      	  trans.contraVz(up,vp,w[i][j][k]),1.0);
    }

//--------------------------------------------------------------------//
// xx̋Eݒ肷
    protected function setBCforU():void{
      var bcYZ:EdgeBound=new YZ(flowBc);
      var bcY:EdgeBound=new Y(flowBc);
      var bcZ:EdgeBound=new Z(flowBc);
      for(var j:int=1;j<ny;j++){
      	for(var k:int=1;k<nz;k++){
      	  if(bcYZ.isWall(0,j,k)){
      	    u[1][j][k]=0.0;
      	    u[0][j][k]=-u[2][j][k];
      	  }
      	  else if(bcYZ.isPeriodic(0,j,k)){
      	    u[1][j][k]=u[nx][j][k];
      	    u[0][j][k]=u[nx-1][j][k];
      	  }
      	  else if(bcYZ.isSlip(0,j,k)){
      	    var up:Vector3D=contraAtU(2,j,k);
      	    u[0][j][k]=grid.transU[2][j][k].vx(-up.x,up.y,up.z);
      	  }
      	  if(bcYZ.isWall(nx-1,j,k)){
      	    u[nx][j][k]=0.0;
      	    u[nx+1][j][k]=-u[nx-1][j][k];
      	  }
      	  else if(bcYZ.isPeriodic(nx-1,j,k)){
      	    u[nx][j][k]=u[1][j][k];
      	    u[nx+1][j][k]=u[2][j][k];
      	  }
      	  else if(bcYZ.isSlip(nx-1,j,k)){
      	    up=contraAtU(nx-1,j,k);
      	    u[nx+1][j][k]=grid.transU[nx-1][j][k].vx(-up.x,up.y,up.z);
      	  }
      	}
      }
      for(var i:int=1;i<=nx;i++){
      	for(j=1;j<ny;j++){
      	  if(bcY.isWall(i-1,j,0)){
      	    u[i][j][0]=-u[i][j][1];
      	  }
      	  else if(bcY.isPeriodic(i-1,j,0)){
      	    u[i][j][0]=u[i][j][nz-1];
      	  }
      	  else if(bcY.isSlip(i-1,j,0)){
      	    up=contraAtU(i,j,1);
      	    u[i][j][0]=grid.transU[i][j][1].vx(up.x,up.y,-up.z);
      	  }
      	  else{
      	    u[i][j][0]=u[i][j][1];
      	  }
      	  if(bcY.isWall(i-1,j,nz-1)){
      	    u[i][j][nz]=-u[i][j][nz-1];
      	  }
      	  else if(bcY.isPeriodic(i-1,j,nz-1)){
      	    u[i][j][nz]=u[i][j][1];
      	  }
      	  else if(bcY.isSlip(i-1,j,nz-1)){
      	    up=contraAtU(i,j,nz-1);
      	    u[i][j][nz]=grid.transU[i][j][nz-1].vx(up.x,up.y,-up.z);
      	  }
      	  else{
      	    u[i][j][nz]=u[i][j][nz-1];
      	  }
      	}
      }
      for(i=1;i<=nx;i++){
      	for(k=1;k<nz;k++){
      	  if(bcZ.isWall(i-1,0,k)){
      	    u[i][0][k]=-u[i][1][k];
      	  }
      	  else if(bcZ.isPeriodic(i-1,0,k)){
      	    u[i][0][k]=u[i][ny-1][k];
      	  }
      	  else if(bcZ.isSlip(i-1,0,k)){
      	    up=contraAtU(i,1,k);
      	    u[i][0][k]=grid.transU[i][1][k].vx(up.x,-up.y,up.z);
      	  }
      	  else{
      	    u[i][0][k]=u[i][1][k];
      	  }
      	  if(bcZ.isWall(i-1,ny-1,k)){
      	    u[i][ny][k]=-u[i][ny-1][k];
      	  }
      	  else if(bcZ.isPeriodic(i-1,ny-1,k)){
      	    u[i][ny][k]=u[i][1][k];
      	  }
      	  else if(bcZ.isSlip(i-1,ny-1,k)){
      	    up=contraAtU(i,ny-1,k);
      	    u[i][ny][k]=grid.transU[i][ny-1][k].vx(up.x,-up.y,up.z);
      	  }
      	  else{
      	    u[i][ny][k]=u[i][ny-1][k];
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// xy̋Eݒ肷
    protected function setBCforV():void{
      var bcZX:EdgeBound=new ZX(flowBc);
      var bcZ:EdgeBound=new Z(flowBc);
      var bcX:EdgeBound=new X(flowBc);
      for(var i:int=1;i<nx;i++){
      	for(var k:int=1;k<nz;k++){
      	  if(bcZX.isWall(i,0,k)){
      	    v[i][1][k]=0.0;
      	    v[i][0][k]=-v[i][2][k];
      	  }
      	  else if(bcZX.isPeriodic(i,0,k)){
      	    v[i][1][k]=v[i][ny][k];
      	    v[i][0][k]=v[i][ny-1][k];
      	  }
      	  else if(bcZX.isSlip(i,0,k)){
      	    var vp:Vector3D=contraAtV(i,2,k);
      	    v[i][0][k]=grid.transV[i][2][k].vy(vp.x,-vp.y,vp.z);
      	  }
      	  if(bcZX.isWall(i,ny-1,k)){
      	    v[i][ny][k]=0.0;
      	    v[i][ny+1][k]=-v[i][ny-1][k];
      	  }
      	  else if(bcZX.isPeriodic(i,ny-1,k)){
      	    v[i][ny][k]=v[i][1][k];
      	    v[i][ny+1][k]=v[i][2][k];
      	  }
      	  else if(bcZX.isSlip(i,ny-1,k)){
      	    vp=contraAtV(i,ny-1,k);
      	    v[i][ny+1][k]=grid.transV[i][ny-1][k].vy(vp.x,-vp.y,vp.z);
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(var j:int=1;j<=ny;j++){
      	  if(bcX.isWall(i,j-1,0)){
      	    v[i][j][0]=-v[i][j][1];
      	  }
      	  else if(bcX.isPeriodic(i,j-1,0)){
      	    v[i][j][0]=v[i][j][nz-1];
      	  }
      	  else if(bcX.isSlip(i,j-1,0)){
      	    vp=contraAtV(i,j,1);
      	    v[i][j][0]=grid.transV[i][j][1].vy(vp.x,vp.y,-vp.z);
      	  }
      	  else{
      	    v[i][j][0]=v[i][j][1];
      	  }
      	  if(bcX.isWall(i,j-1,nz-1)){
      	    v[i][j][nz]=-vv[i][j][nz-1];
      	  }
      	  else if(bcX.isPeriodic(i,j-1,nz-1)){
      	    v[i][j][nz]=v[i][j][1];
      	  }
      	  else if(bcX.isSlip(i,j-1,nz-1)){
      	    vp=contraAtV(i,j,nz-1);
      	    v[i][j][nz]=grid.transV[i][j][nz-1].vy(vp.x,vp.y,-vp.z);
     	  }
      	  else{
      	    v[i][j][nz]=v[i][j][nz-1];
      	  }
      	}
      }
      for(j=1;j<=ny;j++){
      	for(k=1;k<nz;k++){
      	  if(bcZ.isWall(0,j-1,k)){
      	    v[0][j][k]=-v[1][j][k];
      	  }
      	  else if(bcZ.isPeriodic(0,j-1,k)){
      	    v[0][j][k]=v[nx-1][j][k];
      	  }
      	  else if(bcZ.isSlip(0,j-1,k)){
      	    vp=contraAtV(1,j,k);
      	    v[0][j][k]=grid.transV[1][j][k].vy(-vp.x,vp.y,vp.z);
      	  }
      	  else{
      	    v[0][j][k]=v[1][j][k];
      	  }
      	  if(bcZ.isWall(nx-1,j-1,k)){
      	    v[nx][j][k]=-v[nx-1][j][k];
      	  }
      	  else if(bcZ.isPeriodic(nx-1,j-1,k)){
      	    v[nx][j][k]=v[1][j][k];
      	  }
      	  else if(bcZ.isSlip(nx-1,j-1,k)){
      	    vp=contraAtV(nx-1,j,k);
      	    v[nx][j][k]=grid.transV[nx-1][j][k].vy(-vp.x,vp.y,vp.z);
      	  }
      	  else{
      	    v[nx][j][k]=v[nx-1][j][k];
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// xz̋Eݒ肷
    protected function setBCforW():void{
      var bcXY:EdgeBound=new XY(flowBc);
      var bcX:EdgeBound=new X(flowBc);
      var bcY:EdgeBound=new Y(flowBc);
      for(var i:int=1;i<nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  if(bcXY.isWall(i,j,0)){
      	    w[i][j][1]=0.0;
      	    w[i][j][0]=-w[i][j][2];
      	  }
      	  else if(bcXY.isPeriodic(i,j,0)){
      	    w[i][j][1]=w[i][j][nz];
      	    w[i][j][0]=w[i][j][nz-1];
      	  }
      	  else if(bcXY.isSlip(i,j,0)){
      	    var wp:Vector3D=contraAtW(i,j,2);
      	    w[i][j][0]=grid.transW[i][j][2].vy(wp.x,wp.y,-wp.z);
      	  }
      	  if(bcXY.isWall(i,j,nz-1)){
      	    w[i][j][nz]=0.0;
      	    w[i][j][nz+1]=-w[i][j][nz-1];
      	  }
      	  else if(bcXY.isPeriodic(i,j,nz-1)){
      	    w[i][j][nz]=w[i][j][1];
      	    w[i][j][nz+1]=w[i][j][2];
      	  }
      	  else if(bcXY.isSlip(i,j,nz-1)){
      	    wp=contraAtW(i,j,nz-1);
      	    w[i][j][nz+1]=grid.transW[i][j][nz-1].vy(wp.x,wp.y,-wp.z);
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(var k:int=1;k<=nz;k++){
      	  if(bcX.isWall(i,0,k-1)){
      	    w[i][0][k]=-w[i][1][k];
      	  }
      	  else if(bcX.isPeriodic(i,0,k-1)){
      	    w[i][0][k]=w[i][ny-1][k];
      	  }
      	  else if(bcX.isSlip(i,0,k-1)){
      	    wp=contraAtW(i,1,k);
      	    w[i][0][k]=grid.transW[i][1][k].vz(wp.x,-wp.y,wp.z);
      	  }
      	  else{
      	    w[i][0][k]=w[i][1][k];
      	  }
      	  if(bcX.isWall(i,ny-1,k-1)){
      	    w[i][ny][k]=-w[i][ny-1][k];
      	  }
      	  else if(bcX.isPeriodic(i,ny-1,k-1)){
      	    w[i][ny][k]=w[i][1][k];
      	  }
      	  else if(bcX.isSlip(i,ny-1,k-1)){
      	    wp=contraAtW(i,ny-1,k);
      	    w[i][ny][k]=grid.transW[i][ny-1][k].vz(wp.x,-wp.y,wp.z);
     	  }
      	  else{
      	    w[i][ny][k]=w[i][ny-1][k];
      	  }
      	}
      }
      for(j=1;j<ny;j++){
      	for(k=1;k<=nz;k++){
      	  if(bcY.isWall(0,j,k-1)){
      	    w[0][j][k]=-w[1][j][k];
      	  }
      	  else if(bcY.isPeriodic(0,j,k-1)){
      	    w[0][j][k]=w[nx-1][j][k];
      	  }
      	  else if(bcY.isSlip(0,j,k-1)){
      	    wp=contraAtW(1,j,k);
      	    w[0][j][k]=grid.transW[1][j][k].vy(-wp.x,wp.y,wp.z);
      	  }
      	  else{
      	    w[0][j][k]=w[1][j][k];
      	  }
      	  if(bcY.isWall(nx-1,j,k-1)){
      	    w[nx][j][k]=-w[nx-1][j][k];
      	  }
      	  else if(bcY.isPeriodic(nx-1,j,k-1)){
      	    w[nx][j][k]=w[1][j][k];
      	  }
      	  else if(bcY.isSlip(nx-1,j,k-1)){
      	    wp=contraAtW(nx-1,j,k);
      	    w[nx][j][k]=grid.transW[nx-1][j][k].vy(-wp.x,wp.y,wp.z);
      	  }
      	  else{
      	    w[nx][j][k]=w[nx-1][j][k];
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// iqp[^̋Eݒ肷
// bc - E
// p - p[^̃Xg
// p0 - p[^̊iq_̏̃Xg
    protected function setBCforC(bc:BoundaryCondition,p:Array,
      	      	      	      	 p0:Array):void{
      var bcXY:EdgeBound=new XY(bc);
      var bcYZ:EdgeBound=new YZ(bc);
      var bcZX:EdgeBound=new ZX(bc);
      for(var k:int=0;k<=nz;k++){
      	var kper:int=k;
      	var km:int=k-1;
      	var kp:int=k;
      	if(k==0){
      	  kper=nz-1;
      	  km=0;
      	}
      	if(k==nz){
      	  kper=1;
      	  kp=nz-1;
      	}
      	for(var j:int=0;j<=ny;j++){
      	  var jper:int=j;
      	  var jm:int=j-1;
      	  var jp:int=j;
      	  if(j==0){
      	    jper=ny-1;
      	    jm=0;
      	  }
      	  if(j==ny){
      	    jper=1;
      	    jp=ny-1;
      	  }
      	  if(bcYZ.isPeriodic(0,j,k)){
      	    p[0][j][k]=p[nx-1][jper][kper];
      	  }
      	  else if(bcYZ.isFix(0,j,k)){
      	    p[0][j][k]=0.5*(p0[0][jm][km]+p0[0][jp][km]+p0[0][jm][kp]
      	      	      	   +p0[0][jp][kp])-p[1][j][k];
      	  }
      	  else{
      	    p[0][j][k]=p[1][j][k];
      	  }
      	  if(bcYZ.isPeriodic(nx-1,j,k)){
      	    p[nx][j][k]=p[1][jper][kper];
      	  }
      	  else if(bcYZ.isFix(nx-1,j,k)){
      	    p[nx][j][k]=0.5*(p0[nx-1][jm][km]+p0[nx-1][jp][km]
      	      	      	    +p0[nx-1][jm][kp]+p0[nx-1][jp][kp])
      	      	      	-p[nx-1][j][k];
      	  }
      	  else{
      	    p[nx][j][k]=p[nx-1][j][k];
      	  }
      	}
      	for(var i:int=0;i<=nx;i++){
      	  var iper:int=i;
      	  var im:int=i-1;
      	  var ip:int=i;
      	  if(i==0){
      	    iper=nx-1;
      	    im=0;
      	  }
      	  if(i==nx){
      	    iper=1;
      	    ip=nx-1;
      	  }
      	  if(bcZX.isPeriodic(i,0,k)){
      	    p[i][0][k]=p[iper][ny-1][kper];
      	  }
      	  else if(bcZX.isFix(i,0,k)){
      	    p[i][0][k]=0.5*(p0[im][0][km]+p0[ip][0][km]+p0[im][0][kp]
      	      	      	   +p0[ip][0][kp])-p[i][1][k];
      	  }
      	  else{
      	    p[i][0][k]=p[i][1][k];
      	  }
      	  if(bcZX.isPeriodic(i,ny-1,k)){
      	    p[i][ny][k]=p[iper][1][kper];
      	  }
      	  else if(bcZX.isFix(i,ny-1,k)){
      	    p[i][ny][k]=0.5*(p0[im][ny-1][km]+p0[ip][ny-1][km]
      	      	      	    +p0[im][ny-1][kp]+p0[ip][ny-1][kp])
      	      	      	-p[i][ny-1][k];
      	  }
      	  else{
      	    p[i][ny][k]=p[i][ny-1][k];
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<ny;j++){
      	  if(bcXY.isPeriodic(i,j,0)){
      	    p[i][j][0]=p[i][j][nz-1];
      	  }
      	  else if(bcXY.isFix(i,j,0)){
      	    p[i][j][0]=0.5*(p0[i-1][j-1][0]+p0[i][j-1][0]+p0[i-1][j][0]
      	      	      	   +p0[i][j][0])-p[i][j][1];
      	  }
      	  else{
      	    p[i][j][0]=p[i][j][1];
      	  }
      	  if(bcXY.isPeriodic(i,j,nz-1)){
      	    p[i][j][nz]=p[i][j][1];
      	  }
      	  else if(bcXY.isFix(i,j,nz-1)){
      	    p[i][j][nz]=0.5*(p0[i-1][j-1][nz-1]+p0[i][j-1][nz-1]
      	      	      	    +p0[i-1][j][nz-1]+p0[i][j][nz-1])
      	      	      	-p[i][j][nz-1];
      	  }
      	  else{
      	    p[i][j][nz]=p[i][j][nz-1];
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// fʊiq_̃XgԂ
    public function getSectionGrid():Array{
      return grid.getSection(section);
    }

//--------------------------------------------------------------------//
// iq_̑x̃XgԂ
    public function getGridV():Array{
      var vg:Array=new Array(nx);
      for(var i:int=0;i<nx;i++){
      	vg[i]=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  vg[i][j]=new Vector.<Vector3D>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    vg[i][j][k]=new Vector3D
      	      (0.25*(u[i+1][j][k]+u[i+1][j+1][k]
      	      	    +u[i+1][j][k+1]+u[i+1][j+1][k+1]),
      	       0.25*(v[i][j+1][k]+v[i+1][j+1][k]
      	      	    +v[i][j+1][k+1]+v[i+1][j+1][k+1]),
      	       0.25*(w[i][j][k+1]+w[i+1][j][k+1]
      	      	    +w[i][j+1][k+1]+w[i+1][j+1][k+1]));
      	  }
      	}
      }
      return vg;
    }

//--------------------------------------------------------------------//
// iq_̑x̍őlԂ
    public function getMaxV():Number{
      var vMax:Number=0.0;
      for(var i:int=0;i<nx;i++){
      	for(var j:int=0;j<ny;j++){
      	  for(var k:int=0;k<nz;k++){
      	    var ug:Number=u[i+1][j][k]+u[i+1][j+1][k]
      	      	      	 +u[i+1][j][k+1]+u[i+1][j+1][k+1];
      	    var vg:Number=v[i][j+1][k]+v[i+1][j+1][k]
      	      	      	 +v[i][j+1][k+1]+v[i+1][j+1][k+1];
      	    var wg:Number=w[i][j][k+1]+w[i+1][j][k+1]
      	      	      	 +w[i][j+1][k+1]+w[i+1][j+1][k+1];
      	    vMax=Math.max(vMax,ug*ug+vg*vg+wg*wg);
      	  }
      	}
      }
      return 0.25*Math.sqrt(vMax);
    }

//--------------------------------------------------------------------//
// fʊiq_̑x̃XgԂ
    public function getSectionV():Array{
      return section.getSectionV(nx,ny,nz,u,v,w);
    }

//--------------------------------------------------------------------//
// iq_̈͂̃XgԂ
    public function getGridPressure():Array{
      return atGridPoint(p);
    }

//--------------------------------------------------------------------//
// fʊiq_̈͂̃XgԂ
    public function getSectionPressure():Array{
      return section.atSectionPoint(nx,ny,nz,p);
    }

//--------------------------------------------------------------------//
// iq_̃p[^̃XgԂ
// p iqS_̃p[^̃Xg
    protected function atGridPoint(p:Array):Array{
      var pp:Array=new Array(nx);
      for(var i:int=0;i<nx;i++){
      	pp[i]=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  pp[i][j]=new Vector.<Number>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    pp[i][j][k]=0.125*(p[i][j][k]+p[i][j+1][k]
      	      	      	      +p[i+1][j][k]+p[i+1][j+1][k]
      	      	      	      +p[i][j][k+1]+p[i][j+1][k+1]
      	      	      	      +p[i+1][j][k+1]+p[i+1][j+1][k+1]);
      	  }
      	}
      }
      return pp;
    }

//--------------------------------------------------------------------//
// QxvZXgԂ
    public function vorticity():Array{
      var vor:Array=new Array(nx);
      for(var i:int=0;i<nx;i++){
      	vor[i]=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  vor[i][j]=new Vector.<Vector3D>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    var dux:Number=0.125*(u[i+2][j+1][k+1]-u[i][j+1][k+1]
      	      	      	      	 +u[i+2][j][k+1]-u[i][j][k+1]
      	      	      	      	 +u[i+2][j+1][k]-u[i][j+1][k]
      	      	      	      	 +u[i+2][j][k]-u[i][j][k]);
      	    var duy:Number=0.5*(u[i+1][j+1][k+1]-u[i+1][j][k+1]
      	      	      	       +u[i+1][j+1][k]-u[i+1][j][k]);
      	    var duz:Number=0.5*(u[i+1][j+1][k+1]-u[i+1][j+1][k]
      	      	      	       +u[i+1][j][k+1]-u[i+1][j][k]);
      	    var dudy:Number=grid.trans[i+1][j+1][k+1].dpdy(dux,duy,duz);
      	    var dudz:Number=grid.trans[i+1][j+1][k+1].dpdz(dux,duy,duz);
      	    var dvx:Number=0.5*(v[i+1][j+1][k+1]-v[i][j+1][k+1]
      	      	      	       +v[i+1][j+1][k]-v[i][j+1][k]);
      	    var dvy:Number=0.125*(v[i+1][j+2][k+1]-v[i+1][j][k+1]
      	      	      	      	 +v[i][j+2][k+1]-v[i][j][k+1]
      	      	      	      	 +v[i+1][j+2][k]-v[i+1][j][k]
      	      	      	      	 +v[i][j+2][k]-v[i][j][k]);
      	    var dvz:Number=0.5*(v[i+1][j+1][k+1]-v[i+1][j+1][k]
      	      	      	       +v[i][j+1][k+1]-v[i][j+1][k]);
      	    var dvdx:Number=grid.trans[i+1][j+1][k+1].dpdx(dvx,dvy,dvz);
      	    var dvdz:Number=grid.trans[i+1][j+1][k+1].dpdz(dvx,dvy,dvz);
      	    var dwx:Number=0.5*(w[i+1][j+1][k+1]-w[i][j+1][k+1]
      	      	      	       +w[i+1][j][k+1]-w[i][j][k+1]);
      	    var dwy:Number=0.5*(w[i+1][j+1][k+1]-w[i+1][j][k+1]
      	      	      	       +w[i][j+1][k+1]-w[i][j][k+1]);
      	    var dwz:Number=0.125*(w[i+1][j+1][k+2]-w[i+1][j+1][k]
      	      	      	      	 +w[i][j+1][k+2]-w[i][j+1][k]
      	      	      	      	 +w[i+1][j][k+2]-w[i+1][j][k]
      	      	      	      	 +w[i][j][k+2]-w[i][j][k]);
       	    var dwdx:Number=grid.trans[i+1][j+1][k+1].dpdx(dwx,dwy,dwz);
      	    var dwdy:Number=grid.trans[i+1][j+1][k+1].dpdy(dwx,dwy,dwz);
      	    vor[i][j][k]=new Vector3D(dwdy-dvdz,dudz-dwdx,dvdx-dudy,
      	      	      	      	      1.0);
      	  }
      	}
      }
      return vor;
    }
  }
}
