package{

//--------------------------------------------------------------------//
// E
  public class BoundaryCondition{

// Eݒ薳
    public static const NONE:uint=0;

// 
    public static const SLIP:uint=1;

// Ǐ
    public static const WALL:uint=2;

// 
    public static const INLET:uint=3;

// o
    public static const OUTLET:uint=4;

// E
    public static const PERIODIC:uint=5;

// fM
    public static const INSULATE:uint=2;

// Œ
    public static const FIX:uint=4;

// xiq_
    public var nx:int;

// yiq_
    public var ny:int;

// ziq_
    public var nz:int;

// ẼXg
    protected var bc:Array;

//--------------------------------------------------------------------//
// E\z
// nx - xiq_
// ny - yiq_
// nz - ziq_
    public function BoundaryCondition(nx:int=0,ny:int=0,nz:int=0){
      create(nx,ny,nz);
    }

//--------------------------------------------------------------------//
// EԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function get(i:int,j:int,k:int):uint{
      i=Math.min(Math.max(i,0),nx-1);
      j=Math.min(Math.max(j,0),ny-1);
      k=Math.min(Math.max(k,0),nz-1);
      return bc[i][j][k];
    }

//--------------------------------------------------------------------//
// Eݒ肷
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
// bc - ݒ肷鋫E
    public function set(i:int,j:int,k:int,bc:uint):void{
      this.bc[i][j][k]=bc;
    }

//--------------------------------------------------------------------//
// x+ʂ̋Eݒ肷
// bc - ݒ肷鋫E
    public function setXp(bc:uint):void{
      for(var j:int=0;j<ny;j++){
      	for(var k:int=0;k<nz;k++){
      	  this.bc[nx-1][j][k]=bc;
      	}
      }
    }

//--------------------------------------------------------------------//
// x-ʂ̋Eݒ肷
// bc - ݒ肷鋫E
    public function setXm(bc:uint):void{
      for(var j:int=0;j<ny;j++){
      	for(var k:int=0;k<nz;k++){
      	  this.bc[0][j][k]=bc;
      	}
      }
    }

//--------------------------------------------------------------------//
// y+Eݒ肷
// bc - ݒ肷鋫E
    public function setYp(bc:uint):void{
      for(var i:int=0;i<nx;i++){
      	for(var k:int=0;k<nz;k++){
      	  this.bc[i][ny-1][k]=bc;
      	}
      }
    }

//--------------------------------------------------------------------//
// y-Eݒ肷
// bc - ݒ肷鋫E
    public function setYm(bc:uint):void{
      for(var i:int=0;i<nx;i++){
      	for(var k:int=0;k<nz;k++){
      	  this.bc[i][0][k]=bc;
      	}
      }
    }

//--------------------------------------------------------------------//
// z+Eݒ肷
// bc - ݒ肷鋫E
    public function setZp(bc:uint):void{
      for(var i:int=0;i<nx;i++){
      	for(var j:int=0;j<ny;j++){
      	  this.bc[i][j][nz-1]=bc;
      	}
      }
    }

//--------------------------------------------------------------------//
// z-Eݒ肷
// bc - ݒ肷鋫E
    public function setZm(bc:uint):void{
      for(var i:int=0;i<nx;i++){
      	for(var j:int=0;j<ny;j++){
      	  this.bc[i][j][0]=bc;
      	}
      }
    }

//--------------------------------------------------------------------//
// E쐬
// nx - xiq_
// ny - yiq_
// nz - ziq_
    public function create(nx:int,ny:int,nz:int):void{
      this.nx=nx;
      this.ny=ny;
      this.nz=nz;
      bc=new Array(nx);
      for(var i:int=0;i<nx;i++){
      	bc[i]=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  bc[i][j]=new Vector.<uint>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    bc[i][j][k]=NONE;
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// vZ̑ΏۂƂȂꍇ true
// bc - E
    public static function isCalcBc(bc:uint):Boolean{
      return ((bc==NONE) || (bc==SLIP) || (bc==PERIODIC));
    }

//--------------------------------------------------------------------//
// w肳ꂽʒuvZ̑ΏۂƂȂꍇ true
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function isCalc(i:int,j:int,k:int):Boolean{
      return isCalcBc(bc[i][j][k]);
    }
  }
}
