package{
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.geom.Rectangle;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import component.TextBox;

//--------------------------------------------------------------------//
// J[o[̃NX
  public class ColorBar{

// J[o[͈͂̍ŏl
    protected static const MINIMUM_RANGE:Number=1.0E-12;

// J[o[\̋
    protected static const MARGIN:int=2;

// ŏl
    public var minValue:Number;

// ől
    public var maxValue:Number;

// W
    protected var coef:Number;

// ŏlx
    protected var minLabel:TextField;

// őlx
    protected var maxLabel:TextField;

//--------------------------------------------------------------------//
// J[o[\z
// minValue - ŏl
// maxValue - ől
    public function ColorBar(minValue:Number=0.0,maxValue:Number=1.0){
      set(minValue,maxValue);
    }

//--------------------------------------------------------------------//
// 0 ` 1 ̒lɑ΂J[o[̐FԂ
// value - Qƒl
    protected function normColor(value:Number):uint{
      return 0x000000;
    }

//--------------------------------------------------------------------//
// lɑ΂J[o[̐FԂ
// value - Qƒl
    public function color(value:Number):uint{
      return normColor(coef*(value-minValue));
    }

//--------------------------------------------------------------------//
// f[^͈͂ݒ肷
// v1 - ŏl
// v2 - ől
    public function set(v1:Number,v2:Number):void{
      minValue=Math.min(v1,v2);
      maxValue=Math.max(v1,v2);
      if((maxValue-minValue)<MINIMUM_RANGE)
      	maxValue=minValue+MINIMUM_RANGE;
      coef=1.0/(maxValue-minValue);
    }

//--------------------------------------------------------------------//
// J[o[̍őlEŏlxݒ肷
// sprite - eXvCg
// textFormat - eLXg
    public function setLabels(sprite:Sprite,textFormat:TextFormat):void{
      minLabel=new TextField();
      minLabel.defaultTextFormat=textFormat;
      minLabel.selectable=false;
      maxLabel=new TextField();
      maxLabel.defaultTextFormat=textFormat;
      maxLabel.selectable=false;
      sprite.addChild(minLabel);
      sprite.addChild(maxLabel);
    }

//--------------------------------------------------------------------//
// J[o[`悷
// graphics - `OtBbNX
// rect - J[o[̕`͈
    public function drawVerticalBar(graphics:Graphics,
      	      	      	      	    rect:Rectangle):void{
      var dv:Number=(maxValue-minValue)/(rect.height-1.0);
      var value:Number=minValue;
      var ly:Number=rect.bottom-1.0;
      for(var i:int=0;i<rect.height;i++){
      	graphics.lineStyle(1,color(value));
      	graphics.moveTo(rect.x,ly);
      	graphics.moveTo(rect.right,ly);
      	ly--;
      	value+=dv;
      }
      minLabel.text=barLabel(minValue);
      var textH:Number=minLabel.textHeight/2;
      minLabel.x=rect.right+MARGIN;
      minLabel.y=rect.bottom-textH;
      maxLabel.text=barLabel(maxValue);
      maxLabel.x=rect.right+MARGIN;
      maxLabel.y=rect.y-textH;
    }

//--------------------------------------------------------------------//
// J[o[`悷
// graphics - `OtBbNX
// rect - J[o[̕`͈
    public function drawHorizontalBar(graphics:Graphics,
      	      	      	      	      rect:Rectangle):void{
      var dv:Number=(maxValue-minValue)/(rect.width-1.0);
      var value:Number=minValue;
      var lx:Number=rect.x;
      for(var i:int=0;i<rect.width;i++){
      	graphics.lineStyle(1,color(value));
      	graphics.moveTo(lx,rect.y);
      	graphics.moveTo(lx,rect.bottom);
      	lx++;
      	value+=dv;
      }
      minLabel.text=barLabel(minValue);
      var textH:Number=minLabel.textHeight/2;
      minLabel.x=rect.x-minLabel.textWidth/2;
      minLabel.y=rect.bottom+MARGIN;
      maxLabel.text=barLabel(maxValue);
      maxLabel.x=rect.right-maxLabel.textWidth/2;
      maxLabel.y=rect.y+MARGIN;
    }

//--------------------------------------------------------------------//
// l̕\Ԃ
// value - l
    internal function barLabel(value:Number):String{
      var vabs:Number=Math.abs(value);
      if(vabs>=1.0E5){
      	return String(value);
      }
      else if((vabs>=1.0) || (value==0.0)){
      	return TextBox.format(value,1);
      }
      else if(vabs>=0.001){
      	return TextBox.format(value,4);
      }
      else{
      	return String(value);
      }
    }
  }
}
