package{

//--------------------------------------------------------------------//
// ̈[̋E
  public class EdgeBound{

// E
    protected var bc:BoundaryCondition;

//--------------------------------------------------------------------//
// ̈[̋E\z
// bc - E
    public function EdgeBound(bc:BoundaryCondition){
      this.bc=bc;
    }

//--------------------------------------------------------------------//
// ɍvꍇ true
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
// condition - E
    public function isCondition(i:int,j:int,k:int,
      	      	      	      	condition:uint):Boolean{
      return true;
    }

//--------------------------------------------------------------------//
// ǂłꍇ true
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function isWall(i:int,j:int,k:int):Boolean{
      return isCondition(i,j,k,BoundaryCondition.WALL);
    }

//--------------------------------------------------------------------//
// łꍇ true
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function isSlip(i:int,j:int,k:int):Boolean{
      return isCondition(i,j,k,BoundaryCondition.SLIP);
    }

//--------------------------------------------------------------------//
// Ełꍇ true
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function isPeriodic(i:int,j:int,k:int):Boolean{
      return isCondition(i,j,k,BoundaryCondition.PERIODIC);
    }

//--------------------------------------------------------------------//
// Œłꍇ true
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function isFix(i:int,j:int,k:int):Boolean{
      return isCondition(i,j,k,BoundaryCondition.FIX);
    }

//--------------------------------------------------------------------//
// łꍇ true
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function isInlet(i:int,j:int,k:int):Boolean{
      return isCondition(i,j,k,BoundaryCondition.INLET);
    }

//--------------------------------------------------------------------//
// ołꍇ ture
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function isOutlet(i:int,j:int,k:int):Boolean{
      return isCondition(i,j,k,BoundaryCondition.OUTLET);
    }

//--------------------------------------------------------------------//
// ӂǂłꍇ ture
// bc1 - iq_P̋E
// bc2 - iq_Q̋E
    public function isWallEdge(bc1:uint,bc2:uint):Boolean{
      return isConditionEdge(bc1,bc2,BoundaryCondition.WALL);
    }

//--------------------------------------------------------------------//
// ʂǂłꍇ ture
// bc1 - iq_P̋E
// bc2 - iq_Q̋E
// bc3 - iq_R̋E
// bc4 - iq_S̋E
    public function isWallFace(bc1:uint,bc2:uint,bc3:uint,
      	      	      	       bc4:uint):Boolean{
      return isConditionFace(bc1,bc2,bc3,bc4,BoundaryCondition.WALL);
    }

//--------------------------------------------------------------------//
// ӂɍvꍇ true
// bc1 - iq_P̋E
// bc2 - iq_Q̋E
// condition - E
    public function isConditionEdge(bc1:uint,bc2:uint,
      	      	      	      	    condition:uint):Boolean{
      return ((bc1==condition) || (bc2==condition));
    }

//--------------------------------------------------------------------//
// ʂɍvꍇ true
// bc1 - iq_P̋E
// bc2 - iq_Q̋E
// bc3 - iq_R̋E
// bc4 - iq_S̋E
// condition - E
    public function isConditionFace(bc1:uint,bc2:uint,bc3:uint,bc4:uint,
      	      	      	      	    condition:uint):Boolean{
      return ((bc1==condition) || (bc2==condition) || (bc3==condition)
      	   || (bc4==condition));
    }
  }
}
