package{
  import flash.geom.Vector3D;

//--------------------------------------------------------------------//
// \iqL̐ϖ@f[^f
  public class FVMDataModel extends AbstractFVMDataModel{

// ME
    protected var heatBc:BoundaryCondition;

// x̃Xg
    protected var t:Array;

// x̃Xg
    protected var t0:Array;

// ͕␳̃Xg
    protected var dp:Array;

// x͕̐̈␳W̃Xg
    protected var du:Array;

// xŐ͕̈␳W̃Xg
    protected var dv:Array;

// xĐ͕̈␳W̃Xg
    protected var dw:Array;

// šW̃Xg
    protected var coef:Array;

// d͉x
    protected var gravity:Vector3D;

// xx̌vZ
    protected var uCondition:SORCondition;

// xy̌vZ
    protected var vCondition:SORCondition;

// xžvZ
    protected var wCondition:SORCondition;

// ͂̌vZ
    protected var pCondition:SORCondition;

// x̌vZ
    protected var tCondition:SORCondition;

//--------------------------------------------------------------------//
// \iqL̐ϖ@f[^f\z
    public function FVMDataModel(){
      super();
      heatBc=new BoundaryCondition();
      gravity=new Vector3D();
      uCondition=new SORCondition(2,0.4,1.0e-8);
      vCondition=new SORCondition(2,0.4,1.0e-8);
      wCondition=new SORCondition(2,0.4,1.0e-8);
      pCondition=new SORCondition(10,0.7,1.0e-8);
      tCondition=new SORCondition(3,0.6,1.0e-8);
    }

//--------------------------------------------------------------------//
// MEԂ
    public function getHeatBC():BoundaryCondition{
      return heatBc;
    }

//--------------------------------------------------------------------//
// Eݒ肷
// flowBc - ꋫE
// heatBc - ME
    public function setBoundaryCondition2
      (flowBc:BoundaryCondition,heatBc:BoundaryCondition):void{
      this.flowBc=flowBc;
      this.heatBc=heatBc;
    }

//--------------------------------------------------------------------//
// d͉xݒ肷
// gravity - d͉xxNg
    public function setGravity(gravity:Vector3D):void{
      this.gravity=gravity;
    }

//--------------------------------------------------------------------//
// iq_ݒ肷
    public override function setGrid():void{
      super.setGrid();
      t=new Array(nx+1);
      dp=new Array(nx+1);
      du=new Array(nx+1);
      dv=new Array(nx+1);
      dw=new Array(nx+1);
      coef=new Array(nx+1);
      for(var i:int=0;i<=nx;i++){
      	t[i]=new Array(ny+1);
      	dp[i]=new Array(ny+1);
      	du[i]=new Array(ny+1);
      	dv[i]=new Array(ny+1);
      	dw[i]=new Array(ny+1);
      	coef[i]=new Array(ny+1);
      	for(var j:int=0;j<=ny;j++){
      	  t[i][j]=new Vector.<Number>(nz+1,true);
      	  dp[i][j]=new Vector.<Number>(nz+1,true);
      	  du[i][j]=new Vector.<Number>(nz+1,true);
      	  dv[i][j]=new Vector.<Number>(nz+1,true);
      	  dw[i][j]=new Vector.<Number>(nz+1,true);
      	  coef[i][j]=new Vector.<MatrixCoef>(nz+1,true);
      	  for(var k:int=0;k<=nz;k++){
      	    t[i][j][k]=0.0;
      	    du[i][j][k]=0.0;
      	    dv[i][j][k]=0.0;
      	    dw[i][j][k]=0.0;
      	    coef[i][j][k]=new MatrixCoef();
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// p[^zݒ肷
// ug - iq_̑xx̃Xg
// vg - iq_̑xỹXg
// wg - iq_̑xz̃Xg
// pg - iq_̈͂̃Xg
// tg - iq_̉x̃Xg
    public function setInitField(ug:Array,vg:Array,wg:Array,pg:Array,
      	      	      	      	 tg:Array):void{
      p0=pg;
      t0=tg;
      for(var i:int=1;i<=nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    u[i][j][k]=0.25*(ug[i-1][j-1][k-1]+ug[i-1][j][k-1]
      	      	      	    +ug[i-1][j-1][k]+ug[i-1][j][k]);
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<=ny;j++){
      	  for(k=1;k<nz;k++){
      	    v[i][j][k]=0.25*(vg[i-1][j-1][k-1]+vg[i-1][j-1][k]
      	      	      	    +vg[i][j-1][k-1]+vg[i][j-1][k]);
      	  }
      	}
      	for(j=1;j<ny;j++){
      	  for(k=1;k<=nz;k++){
      	    w[i][j][k]=0.25*(wg[i-1][j-1][k-1]+wg[i][j-1][k-1]
      	      	      	    +wg[i-1][j][k-1]+wg[i][j][k-1]);
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<ny;j++){
      	  for(k=1;k<nz;k++){
      	    p[i][j][k]=0.125*(pg[i][j][k]+pg[i-1][j][k]
      	      	      	     +pg[i][j-1][k]+pg[i-1][j-1][k]
      	      	      	     +pg[i][j][k-1]+pg[i-1][j][k-1]
      	      	      	     +pg[i][j-1][k-1]+pg[i-1][j-1][k-1]);
      	    t[i][j][k]=0.125*(tg[i][j][k]+tg[i-1][j][k]
      	      	      	     +tg[i][j-1][k]+tg[i-1][j-1][k]
      	      	      	     +tg[i][j][k-1]+tg[i-1][j][k-1]
      	      	      	     +tg[i][j-1][k-1]+tg[i-1][j-1][k-1]);
      	  }
      	}
      }
      setBCforU();
      setBCforV();
      setBCforW();
      setBCforC(flowBc,p,p0);
      setBCforC(heatBc,t,t0);
    }

//--------------------------------------------------------------------//
// ̃Xebv̌vZ
    public override function nextStep():void{
      var resU:Number=calcU();
      var resV:Number=calcV();
      var resW:Number=calcW();
      var resP:Number=calcPress();
      updateVel();
      var resT:Number=calcT();
      var residual:Number=Math.max(Math.max(Math.max(resU,resV),resW),
      	      	      	      	   Math.max(resP,resT));
      param.next();
    }

//--------------------------------------------------------------------//
// xxvZcԂ
    protected function calcU():Number{
      contraVarVel();
      var dti:Number=param.dtinv();
      var kvis:Number=material.kvis;
      var dinv:Number=1.0/material.density;
      var buoyant:Number=-material.beta*gravity.x;
      for(var i:int=1;i<=nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    if(flowBc.isCalc(i-1,j-1,k-1) || flowBc.isCalc(i-1,j,k-1)
      	    || flowBc.isCalc(i-1,j,k) || flowBc.isCalc(i-1,j-1,k)){
      	      var uxp:Number=0.5*(uu[i][j][k]+uu[i+1][j][k]);
      	      var uxm:Number=0.5*(uu[i][j][k]+uu[i-1][j][k]);
      	      var vyp:Number=0.5*(vv[i-1][j+1][k]+vv[i][j+1][k]);
      	      var vym:Number=0.5*(vv[i-1][j][k]+vv[i][j][k]);
      	      var wzp:Number=0.5*(ww[i-1][j][k+1]+ww[i][j][k+1]);
      	      var wzm:Number=0.5*(ww[i-1][j][k]+ww[i][j][k]);
      	      var dpx:Number=p[i][j][k]-p[i-1][j][k];
      	      var dpy:Number=0.25*(p[i-1][j+1][k]-p[i-1][j-1][k]
      	      	      	      	  +p[i][j+1][k]-p[i][j-1][k]);
      	      var dpz:Number=0.25*(p[i-1][j][k+1]-p[i-1][j][k-1]
      	      	      	      	  +p[i][j][k+1]-p[i][j][k-1]);
      	      var trans:Transform=grid.transU[i][j][k];
      	      var s:Number=-dinv*trans.dpdx(dpx,dpy,dpz)
      	      	      	   +kvis*grid.diffU[i][j][k].crossTerm(i,j,k,u)
      	      	      	   +buoyant*trans.jacob*t[i][j][k];
      	      coef[i][j][k].setAdDf(uxp,uxm,vyp,vym,wzp,wzm,kvis,s,
      	      	      	      	    grid.diffU[i][j][k]);
      	      coef[i][j][k].setDt(trans.jacob*dti,u[i][j][k]);
      	      du[i][j][k]=dinv*trans.dfuxsi/coef[i][j][k].ac;
      	      coef[i][j][k].setCenter();
      	    }
      	    else{
      	      coef[i][j][k].fix(u[i][j][k]);
      	      du[i][j][k]=0.0;
      	    }
      	  }
      	}
      }
      setBCforU();
      return uCondition.sor(1,1,1,nx+1,ny,nz,u,coef);
    }

//--------------------------------------------------------------------//
// xyvZcԂ
    protected function calcV():Number{
      contraVarVel();
      var dti:Number=param.dtinv();
      var kvis:Number=material.kvis;
      var dinv:Number=1.0/material.density;
      var buoyant:Number=-material.beta*gravity.y;
      for(var i:int=1;i<nx;i++){
      	for(var j:int=1;j<=ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    if(flowBc.isCalc(i-1,j-1,k-1) || flowBc.isCalc(i-1,j-1,k)
      	    || flowBc.isCalc(i,j-1,k-1) || flowBc.isCalc(i,j-1,k)){
      	      var uxp:Number=0.5*(uu[i+1][j-1][k]+uu[i+1][j][k]);
      	      var uxm:Number=0.5*(uu[i][j-1][k]+uu[i][j][k]);
      	      var vyp:Number=0.5*(vv[i][j][k]+vv[i][j+1][k]);
      	      var vym:Number=0.5*(vv[i][j][k]+vv[i][j-1][k]);
      	      var wzp:Number=0.5*(ww[i][j-1][k+1]+ww[i][j][k+1]);
      	      var wzm:Number=0.5*(ww[i][j-1][k]+ww[i][j][k]);
      	      var dpx:Number=0.25*(p[i+1][j-1][k]-p[i-1][j-1][k]
      	      	      	      	  +p[i+1][j][k]-p[i-1][j][k]);
      	      var dpy:Number=p[i][j][k]-p[i][j-1][k];
      	      var dpz:Number=0.25*(p[i][j-1][k+1]-p[i][j-1][k-1]
      	      	      	      	  +p[i][j][k+1]-p[i][j][k-1]);
      	      var trans:Transform=grid.transV[i][j][k];
      	      var s:Number=-dinv*trans.dpdy(dpx,dpy,dpz)
      	      	      	   +kvis*grid.diffV[i][j][k].crossTerm(i,j,k,v)
      	      	      	   +buoyant*trans.jacob*t[i][j][k];
      	      coef[i][j][k].setAdDf(uxp,uxm,vyp,vym,wzp,wzm,kvis,s,
      	      	      	      	    grid.diffV[i][j][k]);
      	      coef[i][j][k].setDt(trans.jacob*dti,v[i][j][k]);
      	      dv[i][j][k]=dinv*trans.dfveta/coef[i][j][k].ac;
      	      coef[i][j][k].setCenter();
      	    }
      	    else{
      	      coef[i][j][k].fix(v[i][j][k]);
      	      dv[i][j][k]=0.0;
      	    }
      	  }
      	}
      }
      setBCforV();
      return vCondition.sor(1,1,1,nx,ny+1,nz,v,coef);
    }

//--------------------------------------------------------------------//
// xzvZcԂ
    protected function calcW():Number{
      contraVarVel();
      var dti:Number=param.dtinv();
      var kvis:Number=material.kvis;
      var dinv:Number=1.0/material.density;
      var buoyant:Number=-material.beta*gravity.z;
      for(var i:int=1;i<nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<=nz;k++){
      	    if(flowBc.isCalc(i-1,j-1,k-1) || flowBc.isCalc(i,j-1,k-1)
      	    || flowBc.isCalc(i-1,j,k-1) || flowBc.isCalc(i,j,k-1)){
      	      var uxp:Number=0.5*(uu[i+1][j-1][k]+uu[i+1][j][k]);
      	      var uxm:Number=0.5*(uu[i][j-1][k]+uu[i][j][k]);
      	      var vyp:Number=0.5*(vv[i-1][j+1][k]+vv[i][j+1][k]);
      	      var vym:Number=0.5*(vv[i-1][j][k]+vv[i][j][k]);
      	      var wzp:Number=0.5*(ww[i][j][k]+ww[i][j][k+1]);
      	      var wzm:Number=0.5*(ww[i][j][k]+ww[i][j][k-1]);
      	      var dpx:Number=0.25*(p[i+1][j][k-1]-p[i-1][j][k-1]
      	      	      	      	  +p[i+1][j][k]-p[i-1][j][k]);
      	      var dpy:Number=0.25*(p[i][j+1][k-1]-p[i][j-1][k-1]
      	      	      	      	  +p[i][j+1][k]-p[i][j-1][k]);
      	      var dpz:Number=p[i][j][k]-p[i][j][k-1];
      	      var trans:Transform=grid.transW[i][j][k];
      	      var s:Number=-dinv*trans.dpdz(dpx,dpy,dpz)
      	      	      	   +kvis*grid.diffW[i][j][k].crossTerm(i,j,k,w)
      	      	      	   +buoyant*trans.jacob*t[i][j][k];
      	      coef[i][j][k].setAdDf(uxp,uxm,vyp,vym,wzp,wzm,kvis,s,
      	      	      	      	    grid.diffW[i][j][k]);
      	      coef[i][j][k].setDt(trans.jacob*dti,w[i][j][k]);
      	      dw[i][j][k]=dinv*trans.dfwzeta/coef[i][j][k].ac;
      	      coef[i][j][k].setCenter();
      	    }
      	    else{
      	      coef[i][j][k].fix(w[i][j][k]);
      	      dw[i][j][k]=0.0;
      	    }
      	  }
      	}
      }
      setBCforW();
      return wCondition.sor(1,1,1,nx,ny,nz+1,w,coef);
    }

//--------------------------------------------------------------------//
// ͂vZcԂ
    protected function calcPress():Number{
      contraVarVel();
      for(var i:int=1;i<nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    coef[i][j][k].set(du[i+1][j][k],du[i][j][k],dv[i][j+1][k],
      	      	      	      dv[i][j][k],dw[i][j][k+1],dw[i][j][k],
      	      	      	      uu[i+1][j][k]-uu[i][j][k]+vv[i][j+1][k]
      	      	      	      -vv[i][j][k]+ww[i][j][k+1]-ww[i][j][k]);
      	    coef[i][j][k].setCenter();
      	  }
      	}
      }
      for(i=0;i<=nx;i++){
      	for(j=1;j<=ny;j++){
      	  for(k=1;k<=nz;k++){
      	    dp[i][j][k]=0.0;
      	  }
      	}
      }
      pCondition.sor(1,1,1,nx,ny,nz,dp,coef);
      for(j=1;j<ny;j++){
      	for(k=1;k<nz;k++){
      	  dp[0][j][k]=dp[1][j][k];
      	  dp[nx][j][k]=dp[nx-1][j][k];
      	}
      }
      for(i=0;i<=nx;i++){
      	for(k=1;k<nz;k++){
      	  dp[i][0][k]=dp[i][1][k];
      	  dp[i][ny][k]=dp[i][ny-1][k];
      	}
      }
      for(i=0;i<=nx;i++){
      	for(j=1;j<=ny;j++){
      	  dp[i][j][0]=dp[i][j][1];
      	  dp[i][j][nz]=dp[i][j][nz-1];
      	}
      }
      var dps:Number=0.0;
      var ps:Number=0.0;
      var dp0:Number=dp[1][1][1];
      for(i=1;i<nx;i++){
      	for(j=1;j<ny;j++){
      	  for(k=1;k<nz;k++){
      	    p[i][j][k]+=dp[i][j][k]-dp0;
      	    dps+=Math.abs(dp[i][j][k]-dp0);
      	    ps+=Math.abs(p[i][j][k]);
      	  }
      	}
      }
      setBCforC(flowBc,p,p0);
      return dps/ps;
    }

//--------------------------------------------------------------------//
// ԑx玟̃Xebv̑xvZ
    protected function updateVel():void{
      for(var i:int=1;i<=nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    var dvv:Number=0.25*(dv[i][j][k]+dv[i-1][j][k]
      	      	      	      	+dv[i][j+1][k]+dv[i-1][j+1][k]);
      	    var dww:Number=0.25*(dw[i][j][k]+dw[i-1][j][k]
      	      	      	      	+dw[i][j][k+1]+dw[i-1][j][k+1]);
      	    var dpx:Number=dp[i][j][k]-dp[i-1][j][k];
      	    var dpy:Number=0.25*(dp[i-1][j+1][k]-dp[i-1][j-1][k]
      	      	      	      	+dp[i][j+1][k]-dp[i][j-1][k]);
      	    var dpz:Number=0.25*(dp[i-1][j][k+1]-dp[i-1][j][k-1]
      	      	      	      	+dp[i][j][k+1]-dp[i][j][k-1]);
      	    u[i][j][k]+=grid.transU[i][j][k].vx
      	      (du[i][j][k]*dpx,dvv*dpy,dww*dpz);
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<=ny;j++){
      	  for(k=1;k<nz;k++){
      	    var duu:Number=0.25*(du[i][j][k]+du[i+1][j][k]
      	      	      	      	+du[i][j-1][k]+du[i-1][j-1][k]);
      	    dww=0.25*(dw[i][j][k]+dw[i][j][k+1]
      	      	     +dw[i][j-1][k]+dw[i][j-1][k+1]);
      	    dpx=0.25*(dp[i+1][j-1][k]-dp[i-1][j-1][k]
      	      	     +dp[i+1][j][k]-dp[i-1][j][k]);
      	    dpy=dp[i][j][k]-dp[i][j-1][k];
      	    dpz=0.25*(dp[i][j-1][k+1]-dp[i][j-1][k-1]
      	      	     +dp[i][j][k+1]-dp[i][j][k-1]);
      	    v[i][j][k]+=grid.transV[i][j][k].vy
      	      (duu*dpx,dv[i][j][k]*dpy,dww*dpz);
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<ny;j++){
      	  for(k=1;k<=nz;k++){
      	    duu=0.25*(du[i][j][k]+du[i][j][k-1]
      	      	     +du[i+1][j][k]+du[i+1][j][k-1]);
      	    dvv=0.25*(dv[i][j][k]+dv[i][j][k-1]
      	      	     +dv[i][j+1][k]+dv[i][j+1][k-1]);
      	    dpx=0.25*(dp[i+1][j][k-1]-dp[i-1][j][k-1]
      	      	     +dp[i+1][j][k]-dp[i-1][j][k]);
      	    dpy=0.25*(dp[i][j+1][k-1]-dp[i][j-1][k-1]
      	      	     +dp[i][j+1][k]-dp[i][j-1][k]);
      	    dpz=dp[i][j][k]-dp[i][j][k-1];
      	    w[i][j][k]+=grid.transW[i][j][k].vz
      	      (duu*dpx,dvv*dpy,dw[i][j][k]*dpz);
      	  }
      	}
      }
      setBCforU();
      setBCforV();
      setBCforW();
    }

//--------------------------------------------------------------------//
// xvZcԂ
    protected function calcT():Number{
      contraVarVel();
      setBCforC(heatBc,t,t0);
      var dti:Number=param.dtinv();
      var alp:Number=material.alpha;
      for(var i:int=1;i<nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    coef[i][j][k].setAdDf(uu[i+1][j][k],uu[i][j][k],
      	      	      	      	  vv[i][j+1][k],vv[i][j][k],
      	      	      	      	  ww[i][j][k+1],ww[i][j][k],
      	      	      	      	  alp,0.0,grid.diffP[i][j][k]);
      	    coef[i][j][k].setDt(grid.transP[i][j][k].jacob*dti,
      	      	      	      	t[i][j][k]);
      	    coef[i][j][k].setCenter();
      	  }
      	}
      }
      return tCondition.sor(1,1,1,nx,ny,nz,t,coef);
    }

//--------------------------------------------------------------------//
// iq_̉x̃XgԂ
    public function getGridTemperature():Array{
      return atGridPoint(t);
    }

//--------------------------------------------------------------------//
// fʊiq_̉x̃XgԂ
    public function getSectionTemperature():Array{
      return section.atSectionPoint(nx,ny,nz,t);
    }
  }
}
