package{
  import flash.display.Graphics;
  import flash.display.GraphicsPathCommand;
  import flash.display.Sprite;
  import flash.geom.Matrix3D;
  import flash.geom.Vector3D;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import colorbar.Standard;
  import component.ViewModel;
  import figure.Cube3D;
  import figure.Point3D;

//--------------------------------------------------------------------//
// \iqL̐ϖ@\f
  public class FVMViewModel extends ViewModel{

// ̍ŏl
    public static const MIN_VALUE:Number=1.0E-10;

// \iqL̐ϖ@f[^f
    internal var model:FVMDataModel;

// \iqf[^f
    internal var grid:GridModel;

// xiq_
    protected var nx:int;

// yiq_
    protected var ny:int;

// ziq_
    protected var nz:int;

// Wϊ}gbNX
    internal var trans:Matrix3D;

// ]
    internal var axis:Vector3D;

// iq͈
    internal var bounds:Cube3D;

// f\̈TCY
    internal var viewSize:Number;

// fsړW
    internal var transCoef:Number;

// f]xW
    internal var rotateCoef:Number;

// fgEkW
    internal var zoomCoef:Number;

// OiF
    internal var fgColor:uint;

// wiF
    internal var bgColor:uint;

// vf\F
    internal var elemColor:uint;

// x\F
    internal var velColor:uint;

// \f[^̃CfbNX
    internal var result:int;

// vZ\
    internal var info:Vector.<TextField>;

// J[o[
    internal var colorBar:ColorBar;

// `R}h
    internal var commands:Vector.<int>;

// `W
    internal var coords:Vector.<Number>;

//--------------------------------------------------------------------//
// sprite - eXvCg
// model - \iqL̐ϖ@f[^f
// graphics - `OtBbNX
// x,y,width,height - \ʒuAA
// bgColor - wiF
// fgColor - OiF
// textFormat - eLXg
    public function FVMViewModel(sprite:Sprite,model:FVMDataModel,
      	      	      	      	 graphics:Graphics,x:int,y:int,
      	      	      	      	 width:int,height:int,
      	      	      	      	 fgColor:uint,bgColor:uint,
      	      	      	      	 textFormat:TextFormat){
      super(graphics,x,y,width,height);
      this.model=model;
      grid=model.getGridModel();
      trans=new Matrix3D();
      axis=new Vector3D();
      viewSize=Math.min(width,height);
      result=2;
      transCoef=1.0;
      rotateCoef=180.0/viewSize;
      zoomCoef=1.0/viewSize;

      this.fgColor=fgColor;
      this.bgColor=bgColor;
      elemColor=0x999999;
      velColor=0x333333;

      info=new Vector.<TextField>(5,true);
      for(var i:int=0;i<5;i++){
      	info[i]=new TextField();
      	info[i].defaultTextFormat=textFormat;
      	info[i].textColor=fgColor;
      	info[i].backgroundColor=bgColor;
      	info[i].selectable=false;
      	info[i].text=" ";
      	info[i].x=10;
      	info[i].y=30;
      	info[i].height=info[i].textHeight+2;
      	sprite.addChild(info[i]);
      }
      info[0].text="Max. ";
      info[0].width=info[0].textWidth+5;
      info[2].text=" Min. ";
      info[2].width=info[2].textWidth+5;
      info[4].y=5;
      colorBar=new Standard();
      commands=new Vector.<int>();
      coords=new Vector.<Number>();
    }

//--------------------------------------------------------------------//
// \iqL̐ϖ@f[^fԂ
    public function getModel():FVMDataModel{
      return model;
    }

//--------------------------------------------------------------------//
// \iqf[^ݒ肷
    public function setMesh():void{
      nx=grid.nx;
      ny=grid.ny;
      nz=grid.nz;
      bounds=grid.getRange();
    }

//--------------------------------------------------------------------//
// R^[\f[^̎ނݒ肷
// result - f[^̃CfbNX
    public function setResult(result:int):void{
      this.result=result;
    }

//--------------------------------------------------------------------//
// \fʂݒ肷
// sect - fʂ̃CfbNX
    public function setSection(sect:int):void{
      switch(sect){
      	case 0:
      	  model.getSection().set(-1,-1,nz/2);
      	  break;
      	case 1:
      	  model.getSection().set(nx/2,-1,-1);
      	  break;
      	case 2:
      	  model.getSection().set(-1,ny/2,-1);
      	  break;
      }
    }

//--------------------------------------------------------------------//
// f𕽍sړ
// dx,dy - ʏ̈ړ
    public function translate(dx:int,dy:int):void{
      trans.appendTranslation(transCoef*dx,-transCoef*dy,0.0);
    }

//--------------------------------------------------------------------//
// f]
// dx,dy - ʏ̈ړ
    public function rotate(dx:int,dy:int):void{
      var r:Number=Math.sqrt(dx*dx+dy*dy);
      axis.x=dy/r;
      axis.y=dx/r;
      trans.appendRotation(rotateCoef*r,axis);
    }

//--------------------------------------------------------------------//
// gEk
// dx,dy - ʏ̈ړ
    public function zoom(dx:int,dy:int):void{
      var c:Number=Math.pow(2.0,zoomCoef*Number(dx+dy));
      trans.appendScale(c,c,c);
    }

//--------------------------------------------------------------------//
// `ʒu
// z
    public function initView():void{
      trans.identity();
      draw();
    }

//--------------------------------------------------------------------//
// xɂ
    public function viewX():void{
      trans.identity();
      trans.appendRotation(-90.0,Vector3D.Y_AXIS);
      trans.appendRotation(-90.0,Vector3D.Z_AXIS);
      draw();
    }

//--------------------------------------------------------------------//
// yɂ
    public function viewY():void{
      trans.identity();
      trans.appendRotation(-90.0,Vector3D.X_AXIS);
      draw();
    }

//--------------------------------------------------------------------//
// `悷
    public function draw():void{
      drawInit(bgColor);

      var center:Point3D=bounds.getCenterLocation();
      var boundSize:Number=Math.max(Math.max(bounds.width,
      	      	      	      	    bounds.height),bounds.depth);
      var vCoef:Number=0.8*viewSize/Math.max(boundSize,MIN_VALUE);
      var vecMax:Number=0.05*viewSize;
      var velMax:Number=model.getMaxV();

      var gp:Array=model.getSectionGrid();
      var vpp:Array=new Array(gp.length);
      var zMax:Number=-1.0e10;
      for(var i:int=0;i<gp.length;i++){
      	vpp[i]=new Vector.<Vector3D>(gp[i].length,true);
      	for(var j:int=0;j<gp[i].length;j++){
      	  vpp[i][j]=getViewPoint(gp[i][j],vCoef,center);
      	  zMax=Math.max(vpp[i][j].z,zMax);
      	}
      }

      var edge:Vector.<Edge>=getEdges(vCoef,center);
      var beforeView:Vector.<Boolean>=new Vector.<Boolean>(edge.length);
      graphics.lineStyle(1,elemColor);
      commands.length=0;
      coords.length=0;
      for(i=0;i<edge.length;i++){
      	beforeView[i]=((edge[i].p1.z<=zMax) && (edge[i].p2.z<=zMax));
      	if(beforeView[i]){
      	  commands.push(GraphicsPathCommand.MOVE_TO);
      	  coords.push(cx+edge[i].p1.x);
      	  coords.push(cy-edge[i].p1.y);
      	  commands.push(GraphicsPathCommand.LINE_TO);
      	  coords.push(cx+edge[i].p2.x);
      	  coords.push(cy-edge[i].p2.y);
      	}
      }
      graphics.drawPath(commands,coords);
      drawGrid(vpp);

      if(result==1){
      	drawContour(vpp,model.getSectionPressure());
      }
      else if(result==2){
      	drawContour(vpp,model.getSectionTemperature());
      }
      graphics.lineStyle(1,velColor);
      drawVectors(gp,vpp,model.getSectionV(),vecMax,velMax,vCoef,
      	      	  center);

      graphics.lineStyle(1,elemColor);
      commands.length=0;
      coords.length=0;
      for(i=0;i<edge.length;i++){
      	if(!beforeView[i]){
      	  commands.push(GraphicsPathCommand.MOVE_TO);
      	  coords.push(cx+edge[i].p1.x);
      	  coords.push(cy-edge[i].p1.y);
      	  commands.push(GraphicsPathCommand.LINE_TO);
      	  coords.push(cx+edge[i].p2.x);
      	  coords.push(cy-edge[i].p2.y);
      	}
      }
      graphics.drawPath(commands,coords);

      info[4].text=model.getFlowParameter().iteration();
      info[4].width=info[4].textWidth+5;
    }

//--------------------------------------------------------------------//
// f̕ӂ̃XgԂ
// vCoef - f̕\{
// center - f̒S_
    protected function getEdges(vCoef:Number,
      	      	      	      	center:Point3D):Vector.<Edge>{
      var edge:Vector.<Edge>=new Vector.<Edge>(4*(nx+ny+nz-3),true);
      var ii:int=0;
      var vp00:Vector3D=getViewPoint(grid.point(0,0,0),vCoef,center);
      var vp01:Vector3D=getViewPoint(grid.point(0,ny-1,0),vCoef,center);
      var vp02:Vector3D=getViewPoint(grid.point(0,0,nz-1),vCoef,center);
      var vp03:Vector3D=getViewPoint(grid.point(0,ny-1,nz-1),vCoef,
      	      	      	      	     center);
      for(var i:int=1;i<nx;i++){
      	var vp10:Vector3D=getViewPoint(grid.point(i,0,0),vCoef,center);
      	var vp11:Vector3D=getViewPoint(grid.point(i,ny-1,0),vCoef,
      	      	      	      	       center);
      	var vp12:Vector3D=getViewPoint(grid.point(i,0,nz-1),vCoef,
      	      	      	      	       center);
      	var vp13:Vector3D=getViewPoint(grid.point(i,ny-1,nz-1),vCoef,
      	      	      	      	       center);
      	edge[ii]=new Edge(vp00,vp10);
      	edge[ii+1]=new Edge(vp01,vp11);
      	edge[ii+2]=new Edge(vp02,vp12);
      	edge[ii+3]=new Edge(vp03,vp13);
      	ii+=4;
      	vp00=vp10;
      	vp01=vp11;
      	vp02=vp12;
      	vp03=vp13;
      }
      vp00=getViewPoint(grid.point(0,0,0),vCoef,center);
      vp01=getViewPoint(grid.point(nx-1,0,0),vCoef,center);
      vp02=getViewPoint(grid.point(0,0,nz-1),vCoef,center);
      vp03=getViewPoint(grid.point(nx-1,0,nz-1),vCoef,center);
      for(var j:int=1;j<ny;j++){
      	vp10=getViewPoint(grid.point(0,j,0),vCoef,center);
      	vp11=getViewPoint(grid.point(nx-1,j,0),vCoef,center);
      	vp12=getViewPoint(grid.point(0,j,nz-1),vCoef,center);
      	vp13=getViewPoint(grid.point(nx-1,j,nz-1),vCoef,center);
      	edge[ii]=new Edge(vp00,vp10);
      	edge[ii+1]=new Edge(vp01,vp11);
      	edge[ii+2]=new Edge(vp02,vp12);
      	edge[ii+3]=new Edge(vp03,vp13);
      	ii+=4;
      	vp00=vp10;
      	vp01=vp11;
      	vp02=vp12;
      	vp03=vp13;
      }
      vp00=getViewPoint(grid.point(0,0,0),vCoef,center);
      vp01=getViewPoint(grid.point(nx-1,0,0),vCoef,center);
      vp02=getViewPoint(grid.point(0,ny-1,0),vCoef,center);
      vp03=getViewPoint(grid.point(nx-1,ny-1,0),vCoef,center);
      for(var k:int=1;k<nz;k++){
      	vp10=getViewPoint(grid.point(0,0,k),vCoef,center);
      	vp11=getViewPoint(grid.point(nx-1,0,k),vCoef,center);
      	vp12=getViewPoint(grid.point(0,ny-1,k),vCoef,center);
      	vp13=getViewPoint(grid.point(nx-1,ny-1,k),vCoef,center);
      	edge[ii]=new Edge(vp00,vp10);
      	edge[ii+1]=new Edge(vp01,vp11);
      	edge[ii+2]=new Edge(vp02,vp12);
      	edge[ii+3]=new Edge(vp03,vp13);
      	ii+=4;
      	vp00=vp10;
      	vp01=vp11;
      	vp02=vp12;
      	vp03=vp13;
      }
      return edge;
    }

//--------------------------------------------------------------------//
// ʏ̓_Ԃ
// p - _
// vCoef - f̕\{
// center - f̒S
    internal function getViewPoint(p:Point3D,vCoef:Number,
      	      	      	      	   center:Point3D):Vector3D{
      var v:Vector3D=new Vector3D(vCoef*(p.x-center.x),
      	      	      	      	  vCoef*(p.y-center.y),
      	      	      	      	  vCoef*(p.z-center.z),1.0);
      return trans.transformVector(v);
    }

//--------------------------------------------------------------------//
// iq`悷
// vp - iq_̃Xg
    internal function drawGrid(vp:Array):void{
      commands.length=0;
      coords.length=0;
      for(var j:int=0;j<vp[0].length;j++){
      	commands.push(GraphicsPathCommand.MOVE_TO);
      	coords.push(cx+vp[0][j].x);
      	coords.push(cy-vp[0][j].y);
      	for(var i:int=1;i<vp.length;i++){
      	  commands.push(GraphicsPathCommand.LINE_TO);
      	  coords.push(cx+vp[i][j].x);
      	  coords.push(cy-vp[i][j].y);
      	}
      }
      for(i=0;i<vp.length;i++){
       	commands.push(GraphicsPathCommand.MOVE_TO);
      	coords.push(cx+vp[i][0].x);
      	coords.push(cy-vp[i][0].y);
      	for(j=1;j<vp[i].length;j++){
      	  commands.push(GraphicsPathCommand.LINE_TO);
      	  coords.push(cx+vp[i][j].x);
      	  coords.push(cy-vp[i][j].y);
      	}
      }
      graphics.drawPath(commands,coords);
    }

//--------------------------------------------------------------------//
// R^[}`悷
// vp - iq_̃Xg
// z - p[^̃Xg
    internal function drawContour(vp:Array,z:Array):void{
      var zMin:Number=z[0][0];
      var zMax:Number=z[0][0];
      for(var i:int=0;i<z.length;i++){
      	for(var j:int=0;j<z[i].length;j++){
      	  zMin=Math.min(zMin,z[i][j]);
      	  zMax=Math.max(zMax,z[i][j]);
      	}
      }
      var dzi:Number=1.0/(zMax-zMin);

      for(i=0;i<vp.length-1;i++){
      	for(j=0;j<vp[i].length-1;j++){
      	  var xx:Vector.<Number>=Vector.<Number>
      	    ([cx+vp[i][j].x,cx+vp[i+1][j].x,cx+vp[i+1][j+1].x,
      	      cx+vp[i][j+1].x]);
      	  var yy:Vector.<Number>=Vector.<Number>
      	    ([cy-vp[i][j].y,cy-vp[i+1][j].y,cy-vp[i+1][j+1].y,
      	      cy-vp[i][j+1].y]);
      	  var zz:Vector.<Number>=Vector.<Number>
      	    ([dzi*(z[i][j]-zMin),dzi*(z[i+1][j]-zMin),
      	      dzi*(z[i+1][j+1]-zMin),dzi*(z[i][j+1]-zMin)]);
      	  var xp:Vector.<Number>=Vector.<Number>
      	    ([0.25*(xx[0]+xx[1]+xx[2]+xx[3]),0.0,0.0]);
      	  var yp:Vector.<Number>=Vector.<Number>
      	    ([0.25*(yy[0]+yy[1]+yy[2]+yy[3]),0.0,0.0]);
      	  var zp:Vector.<Number>=Vector.<Number>
      	    ([0.25*(zz[0]+zz[1]+zz[2]+zz[3]),0.0,0.0]);
      	  for(var k:int=0;k<4;k++){
      	    xp[1]=xx[k];
      	    yp[1]=yy[k];
      	    zp[1]=zz[k];
      	    xp[2]=xx[(k+1)%4];
      	    yp[2]=yy[(k+1)%4];
      	    zp[2]=zz[(k+1)%4];
      	    drawTriContour(xp,yp,zp);
      	  }
      	}
      }
      info[0].textColor=colorBar.color(1.0);
      info[1].text=zMax.toExponential(3);
      info[1].x=info[0].x+info[0].width+5;
      info[1].width=info[1].textWidth+5;
      info[2].textColor=colorBar.color(0.0);
      info[2].x=info[1].x+info[1].width+5;
      info[3].text=zMin.toExponential(3);
      info[3].width=info[3].textWidth+5;
      info[3].x=info[2].x+info[2].width+5;
    }

//--------------------------------------------------------------------//
// Op`̃R^[}`悷
// x - xW̃Xg
// y - yW̃Xg
// z - p[^̃Xg
    internal function drawTriContour(x:Vector.<Number>,
      	      	      	      	     y:Vector.<Number>,
      	      	      	      	     z:Vector.<Number>):void{
      var cz:Number=10.999;
      var iMax:int=0;
      var iMin:int=0;
      var zMin:Number=z[0];
      var zMax:Number=z[0];
      for(var i:int=1;i<3;i++){
      	if(z[i]>zMax){
      	  zMax=z[i];
      	  iMax=i;
      	}
      	else if(z[i]<zMin){
      	  zMin=z[i];
      	  iMin=i;
      	}
      }
      var iMid:int=3-iMin-iMax;
      var stepMin:int=int(cz*zMin)+1;
      var stepMax:int=int(cz*zMax);
      for(i=stepMin;i<=stepMax;i++){
      	var zp:Number=Number(i)/cz;
      	graphics.lineStyle(1,colorBar.color(zp));
      	var t:Number=(zp-zMin)/(zMax-zMin);
      	graphics.moveTo(x[iMin]+t*(x[iMax]-x[iMin]),
      	      	      	y[iMin]+t*(y[iMax]-y[iMin]));
      	if(zp>z[iMid]){
      	  t=(zp-z[iMid])/(zMax-z[iMid]);
      	  graphics.lineTo(x[iMid]+t*(x[iMax]-x[iMid]),
      	      	      	  y[iMid]+t*(y[iMax]-y[iMid]));
      	}
      	else{
      	  t=(zp-zMin)/(z[iMid]-zMin);
      	  graphics.lineTo(x[iMin]+t*(x[iMid]-x[iMin]),
      	      	      	  y[iMin]+t*(y[iMid]-y[iMin]));
      	}
      }
    }

//--------------------------------------------------------------------//
// xxNg`悷
// gp - iq_i[z
// vp - iq\_i[z
// u - xi[z
// vecMax - xNg\ő咷
// velMax - ő呬x
// vCoef - f̕\{
// center - f̒S_
    internal function drawVectors(gp:Array,vp:Array,u:Array,
      	      	      	      	  vecMax:Number,velMax:Number,
      	      	      	      	  vCoef:Number,center:Point3D):void{
      if(velMax==0.0) return;
      commands.length=0;
      coords.length=0;
      var coef:Number=vecMax/velMax;
      var cc:Number=-0.18*vecMax;
      var ss:Number=0.1*vecMax;
      for(var i:int=0;i<gp.length;i++){
      	for(var j:int=0;j<gp[i].length;j++){
      	  var x0:Number=cx+vp[i][j].x;
      	  var y0:Number=cy-vp[i][j].y;
      	  var vp1:Vector3D=new Vector3D
      	    (vCoef*(gp[i][j].x-center.x)+coef*u[i][j].x,
      	     vCoef*(gp[i][j].y-center.y)+coef*u[i][j].y,
      	     vCoef*(gp[i][j].z-center.z)+coef*u[i][j].z,1.0);
      	  vp1=trans.transformVector(vp1);
      	  var x1:Number=cx+vp1.x;
      	  var y1:Number=cy-vp1.y;
      	  commands.push(GraphicsPathCommand.MOVE_TO);
      	  coords.push(x0);
      	  coords.push(y0);
      	  commands.push(GraphicsPathCommand.LINE_TO);
      	  coords.push(x1);
      	  coords.push(y1);
      	  var dx:Number=vp1.x-vp[i][j].x;
      	  var dy:Number=vp1.y-vp[i][j].y;
      	  var vmag:Number=Math.sqrt(dx*dx+dy*dy);
      	  if(vmag>=1.0e-10){
      	    dx/=vmag;
      	    dy/=vmag;
      	    commands.push(GraphicsPathCommand.LINE_TO);
      	    coords.push(x1+(cc*dx-ss*dy));
      	    coords.push(y1-(ss*dx+cc*dy));
      	    commands.push(GraphicsPathCommand.MOVE_TO);
      	    coords.push(x1);
      	    coords.push(y1);
      	    commands.push(GraphicsPathCommand.LINE_TO);
      	    coords.push(x1+(cc*dx+ss*dy));
      	    coords.push(y1-(-ss*dx+cc*dy));
      	  }
      	}
      }
      graphics.drawPath(commands,coords);
    }
  }
}
