package{
  import flash.geom.Vector3D;
  import figure.Point3D;

//--------------------------------------------------------------------//
// f쐬NX
  public class Generator{

//--------------------------------------------------------------------//
// xi[Z쐬
// model - \iqL̐ϖ@f[^f
    public static function createBenard(model:FVMDataModel):void{
      var nx:int=30;
      var ny:int=30;
      var nz:int=12;
      var h:Number=0.01;
      var grid:Array=new Array(nx);
      var dx:Number=0.05/Number(nx-1);
      var dy:Number=0.05/Number(ny-1);

      var s0:Number=2.0/Number(nz-1);
      var a:Number=1.5;
      var b:Number=(a+1.0)/(a-1.0);
      var cf:Number=h/(b-1.0);
      for(var i:int=0;i<nx;i++){
      	grid[i]=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  grid[i][j]=new Vector.<Point3D>(nz,true);
      	}
      }
      for(var k:int=1;k<nz;k++){
      	var sj:Number=s0*Number(k);
      	var z:Number=cf*(Math.pow(b,sj)-1.0)/(Math.pow(b,sj-1.0)+1.0);
      	grid[0][0][k]=new Point3D(0.0,0.0,z);
      }
      for(i=0;i<nx;i++){
      	var x:Number=dx*Number(i);
      	for(j=0;j<ny;j++){
      	  var y:Number=dy*Number(j);
      	  grid[i][j][0]=new Point3D(x,y,0.0);
      	  for(k=1;k<nz;k++){
      	    grid[i][j][k]=new Point3D(x,y,grid[0][0][k].z);
      	  }
      	}
      }

      var flowBc:BoundaryCondition=new BoundaryCondition(nx,ny,nz);
      var heatBc:BoundaryCondition=new BoundaryCondition(nx,ny,nz);
      flowBc.setXm(BoundaryCondition.PERIODIC);
      flowBc.setXp(BoundaryCondition.PERIODIC);
      flowBc.setYm(BoundaryCondition.PERIODIC);
      flowBc.setYp(BoundaryCondition.PERIODIC);
//      flowBc.setXm(BoundaryCondition.WALL);
//      flowBc.setXp(BoundaryCondition.WALL);
//      flowBc.setYm(BoundaryCondition.WALL);
//      flowBc.setYp(BoundaryCondition.WALL);
      flowBc.setZm(BoundaryCondition.WALL);
      flowBc.setZp(BoundaryCondition.WALL);
      heatBc.setXm(BoundaryCondition.PERIODIC);
      heatBc.setXp(BoundaryCondition.PERIODIC);
      heatBc.setYm(BoundaryCondition.PERIODIC);
      heatBc.setYp(BoundaryCondition.PERIODIC);
//      heatBc.setXm(BoundaryCondition.INSULATE);
//      heatBc.setXp(BoundaryCondition.INSULATE);
//      heatBc.setYm(BoundaryCondition.INSULATE);
//      heatBc.setYp(BoundaryCondition.INSULATE);
      heatBc.setZm(BoundaryCondition.FIX);
      heatBc.setZp(BoundaryCondition.FIX);

      model.setMaterial(new Material(1000.0,1.0e-3,2.0e-4,0.594,
      	      	      	      	     4200.0));
      model.getGridModel().setGrid(nx,ny,nz,grid,flowBc);
      model.setBoundaryCondition2(flowBc,heatBc);
      model.setGrid();

      setBenardField(model);
    }

//--------------------------------------------------------------------//
// xi[Z̃p[^zݒ肷
// model - \iqL̐ϖ@f[^f
    public static function setBenardField(model:FVMDataModel):void{
      var nx:int=30;
      var ny:int=30;
      var nz:int=12;
      var h:Number=0.01;
      var u:Array=new Array(nx);
      var v:Array=new Array(nx);
      var w:Array=new Array(nx);
      var p:Array=new Array(nx);
      var t:Array=new Array(nx);
      var mat:Material=model.getMaterial();
      var grav:Number=9.8;
      var ra:Number=20000.0;
      var tHeat:Number=ra*mat.alpha*mat.kvis/(mat.beta*grav*h*h*h);
      for(var i:int=0;i<nx;i++){
      	u[i]=new Array(ny);
      	v[i]=new Array(ny);
      	w[i]=new Array(ny);
      	p[i]=new Array(ny);
      	t[i]=new Array(ny);
      	for(var j:int=0;j<ny;j++){
      	  u[i][j]=new Vector.<Number>(nz,true);
      	  v[i][j]=new Vector.<Number>(nz,true);
      	  w[i][j]=new Vector.<Number>(nz,true);
      	  p[i][j]=new Vector.<Number>(nz,true);
      	  t[i][j]=new Vector.<Number>(nz,true);
      	  for(var k:int=0;k<nz;k++){
      	    u[i][j][k]=0.0;
      	    v[i][j][k]=0.0;
      	    w[i][j][k]=0.0;
      	    p[i][j][k]=0.0;
      	    t[i][j][k]=0.0;
      	  }
      	  t[i][j][0]=tHeat;
      	}
      }
      model.setInitField(u,v,w,p,t);
      model.setGravity(new Vector3D(0.0,0.0,-grav,1.0));
    }
  }
}
