package{
  import figure.Cube3D;
  import figure.Point3D;

//--------------------------------------------------------------------//
// \iqf[^f
  public class GridModel{

// xiq_
    public var nx:int;

// yiq_
    public var ny:int;

// ziq_
    public var nz:int;

// iq_̃Xg
    protected var grid:Array;

// iq͈
    protected var gridRange:Cube3D;

// iq_̕ϊs̃Xg
    public var trans:Array;

// xx̕ϊs̃Xg
    public var transU:Array;

// xy̕ϊs̃Xg
    public var transV:Array;

// xz̕ϊs̃Xg
    public var transW:Array;

// ͓_̕ϊs̃Xg
    public var transP:Array;

// xx̊gǓW̃Xg
    public var diffU:Array;

// xẙgǓW̃Xg
    public var diffV:Array;

// xz̊gǓW̃Xg
    public var diffW:Array;

// ͓_̊gǓW̃Xg
    public var diffP:Array;

//--------------------------------------------------------------------//
// ʊiq\z
    public function GridModel(){
      nx=0;
      ny=0;
      nz=0;
      gridRange=new Cube3D();
    }

//--------------------------------------------------------------------//
// iqݒ肷
// nx - xiq_
// ny - yiq_
// nz - ziq_
// grid - iq_̃Xg
// bc - E
    public function setGrid(nx:int,ny:int,nz:int,grid:Array,
      	      	      	    bc:BoundaryCondition):void{
      this.nx=nx;
      this.ny=ny;
      this.nz=nz;
      this.grid=grid;
      var xMin:Number=grid[0][0][0].x;
      var yMin:Number=grid[0][0][0].y;
      var zMin:Number=grid[0][0][0].z;
      var xMax:Number=grid[0][0][0].x;
      var yMax:Number=grid[0][0][0].y;
      var zMax:Number=grid[0][0][0].z;
      for(var i:int=0;i<nx;i++){
      	for(var j:int=0;j<ny;j++){
      	  for(var k:int=0;k<nz;k++){
      	    xMin=Math.min(xMin,grid[i][j][k].x);
      	    yMin=Math.min(yMin,grid[i][j][k].y);
      	    zMin=Math.min(zMin,grid[i][j][k].z);
      	    xMax=Math.max(xMax,grid[i][j][k].x);
      	    yMax=Math.max(yMax,grid[i][j][k].y);
      	    zMax=Math.max(zMax,grid[i][j][k].z);
      	  }
      	}
      }
      gridRange.setBounds(xMin,yMin,zMin,xMax-xMin,yMax-yMin,zMax-zMin);
      metric(bc);
    }

//--------------------------------------------------------------------//
// w肳ꂽiq_Ԃ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function point(i:int,j:int,k:int):Point3D{
      return grid[i][j][k];
    }

//--------------------------------------------------------------------//
// w肳ꂽiq_xWԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function getX(i:int,j:int,k:int):Number{
      return grid[i][j][k].x;
    }

//--------------------------------------------------------------------//
// w肳ꂽiq_yWԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function getY(i:int,j:int,k:int):Number{
      return grid[i][j][k].y;
    }

//--------------------------------------------------------------------//
// w肳ꂽiq_zWԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
    public function getZ(i:int,j:int,k:int):Number{
      return grid[i][j][k].z;
    }

//--------------------------------------------------------------------//
// iq͈͂Ԃ
    public function getRange():Cube3D{
      return gridRange;
    }

//--------------------------------------------------------------------//
// fʊiq_̃XgԂ
// section - fʃ|C^
    public function getSection(section:Pointer):Array{
      return section.getSection(nx,ny,nz,grid);
    }

//--------------------------------------------------------------------//
// xvZ
// bc - E
  public function metric(bc:BoundaryCondition):void{
      trans=new Array(nx+2);
      transU=new Array(nx+2);
      transV=new Array(nx+1);
      transW=new Array(nx+1);
      transP=new Array(nx+1);
      diffU=new Array(nx+2);
      diffV=new Array(nx+1);
      diffW=new Array(nx+1);
      diffP=new Array(nx+1);

      for(var i:int=0;i<nx+2;i++){
      	trans[i]=new Array(ny+2);
      	for(var j:int=0;j<ny+2;j++){
      	  trans[i][j]=new Vector.<Transform>(nz+2,true);
      	}
      }
      metricAtGrid(bc);

      for(i=0;i<nx+2;i++){
      	transU[i]=new Array(ny+1);
      	diffU[i]=new Array(ny+1);
      	for(j=0;j<ny+1;j++){
      	  transU[i][j]=new Vector.<Transform>(nz+1,true);
      	  diffU[i][j]=new Vector.<DiffusionCoef>(nz+1,true);
      	  for(var k:int=0;k<nz+1;k++){
      	    transU[i][j][k]=Transform.create4
      	      (trans[i][j][k],trans[i][j+1][k],trans[i][j][k+1],
      	       trans[i][j+1][k+1]);
      	    diffU[i][j][k]=new DiffusionCoef();
      	  }
      	}
      }
      for(i=0;i<nx+1;i++){
      	transV[i]=new Array(ny+2);
      	diffV[i]=new Array(ny+2);
      	for(j=0;j<ny+2;j++){
      	  transV[i][j]=new Vector.<Transform>(nz+1,true);
      	  diffV[i][j]=new Vector.<DiffusionCoef>(nz+1,true);
      	  for(k=0;k<nz+1;k++){
      	    transV[i][j][k]=Transform.create4
      	      (trans[i][j][k],trans[i+1][j][k],trans[i][j][k+1],
      	       trans[i+1][j][k+1]);
      	    diffV[i][j][k]=new DiffusionCoef();
      	  }
      	}
      	transW[i]=new Array(ny+1);
      	diffW[i]=new Array(ny+1);
      	transP[i]=new Array(ny+1);
      	diffP[i]=new Array(ny+1);
      	for(j=0;j<ny+1;j++){
      	  transW[i][j]=new Vector.<Transform>(nz+2,true);
      	  diffW[i][j]=new Vector.<DiffusionCoef>(nz+2,true);
      	  for(k=0;k<nz+2;k++){
      	    transW[i][j][k]=Transform.create4
      	      (trans[i][j][k],trans[i+1][j][k],trans[i][j+1][k],
      	       trans[i+1][j+1][k]);
      	    diffW[i][j][k]=new DiffusionCoef();
      	  }
      	  transP[i][j]=new Vector.<Transform>(nz+1,true);
      	  diffP[i][j]=new Vector.<DiffusionCoef>(nz+1,true);
      	  for(k=0;k<nz+1;k++){
      	    transP[i][j][k]=Transform.create2
      	      (transW[i][j][k],transW[i][j][k+1]);
      	    diffP[i][j][k]=new DiffusionCoef();
      	  }
      	}
      }
      setDiffusionCoef();
    }

//--------------------------------------------------------------------//
// iq_̑xvZ
// bc - E
    protected function metricAtGrid(bc:BoundaryCondition):void{
      for(var i:int=1;i<=nx;i++){
      	for(var j:int=1;j<=ny;j++){
      	  for(var k:int=1;k<=nz;k++){
      	    trans[i][j][k]=createTransform(i-1,j-1,k-1);
      	  }
      	  if(bc.get(i-1,j-1,0)==BoundaryCondition.PERIODIC){
      	    trans[i][j][0]=trans[i][j][nz-1];
      	  }
      	  else{
      	    trans[i][j][0]=trans[i][j][1];
      	  }
      	  if(bc.get(i-1,j-1,nz-1)==BoundaryCondition.PERIODIC){
      	    trans[i][j][nz+1]=trans[i][j][2];
      	  }
      	  else{
      	    trans[i][j][nz+1]=trans[i][j][nz];
      	  }
      	}
      	for(k=0;k<nz+2;k++){
      	  var kk:int=int(Math.min(Math.max(k-1,0),nz-1));
      	  if(bc.get(i-1,0,kk)==BoundaryCondition.PERIODIC){
      	    trans[i][0][k]=trans[i][ny-1][k];
      	  }
      	  else{
      	    trans[i][0][k]=trans[i][1][k];
      	  }
      	  if(bc.get(i-1,ny-1,kk)==BoundaryCondition.PERIODIC){
      	    trans[i][ny+1][k]=trans[i][2][k];
      	  }
      	  else{
      	    trans[i][ny+1][k]=trans[i][ny][k];
      	  }
      	}
      }
      for(j=0;j<ny+2;j++){
      	var jj:int=int(Math.min(Math.max(j-1,0),ny-1));
      	for(k=0;k<nz+2;k++){
      	  kk=int(Math.min(Math.max(k-1,0),nz-1));
      	  if(bc.get(0,jj,kk)==BoundaryCondition.PERIODIC){
      	    trans[0][j][k]=trans[nx-1][j][k];
      	  }
      	  else{
      	    trans[0][j][k]=trans[1][j][k];
      	  }
      	  if(bc.get(nx-1,jj,kk)==BoundaryCondition.PERIODIC){
      	    trans[nx+1][j][k]=trans[2][j][k];
      	  }
      	  else{
      	    trans[nx+1][j][k]=trans[nx][j][k];
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// iq_̕ϊsvZĕԂ
// i - xCfbNX
// j - yCfbNX
// k - zCfbNX
  protected function createTransform(i:int,j:int,k:int):Transform{
      var tr:Array=new Array(3);
      tr[0]=new Vector.<Number>(3,true);
      if(i==0){
      	tr[0][0]=0.5*(-3.0*grid[0][j][k].x+4.0*grid[1][j][k].x
      	      	      -grid[2][j][k].x);
      	tr[0][1]=0.5*(-3.0*grid[0][j][k].y+4.0*grid[1][j][k].y
      	      	      -grid[2][j][k].y);
      	tr[0][2]=0.5*(-3.0*grid[0][j][k].z+4.0*grid[1][j][k].z
      	      	      -grid[2][j][k].z);
      }
      else if(i==nx-1){
      	tr[0][0]=0.5*(grid[nx-3][j][k].x-4.0*grid[nx-2][j][k].x
      	      	      +3.0*grid[nx-1][j][k].x);
      	tr[0][1]=0.5*(grid[nx-3][j][k].y-4.0*grid[nx-2][j][k].y
      	      	      +3.0*grid[nx-1][j][k].y);
      	tr[0][2]=0.5*(grid[nx-3][j][k].z-4.0*grid[nx-2][j][k].z
      	      	      +3.0*grid[nx-1][j][k].z);
      }
      else{
      	tr[0][0]=0.5*(grid[i+1][j][k].x-grid[i-1][j][k].x);
      	tr[0][1]=0.5*(grid[i+1][j][k].y-grid[i-1][j][k].y);
      	tr[0][2]=0.5*(grid[i+1][j][k].z-grid[i-1][j][k].z);
      }
      tr[1]=new Vector.<Number>(3,true);
      if(j==0){
      	tr[1][0]=0.5*(-3.0*grid[i][0][k].x+4.0*grid[i][1][k].x
      	      	      -grid[i][2][k].x);
      	tr[1][1]=0.5*(-3.0*grid[i][0][k].y+4.0*grid[i][1][k].y
      	      	      -grid[i][2][k].y);
      	tr[1][2]=0.5*(-3.0*grid[i][0][k].z+4.0*grid[i][1][k].z
      	      	      -grid[i][2][k].z);
      }
      else if(j==ny-1){
      	tr[1][0]=0.5*(grid[i][ny-3][k].x-4.0*grid[i][ny-2][k].x
      	      	      +3.0*grid[i][ny-1][k].x);
      	tr[1][1]=0.5*(grid[i][ny-3][k].y-4.0*grid[i][ny-2][k].y
      	      	      +3.0*grid[i][ny-1][k].y);
      	tr[1][2]=0.5*(grid[i][ny-3][k].z-4.0*grid[i][ny-2][k].z
      	      	      +3.0*grid[i][ny-1][k].z);
      }
      else{
      	tr[1][0]=0.5*(grid[i][j+1][k].x-grid[i][j-1][k].x);
      	tr[1][1]=0.5*(grid[i][j+1][k].y-grid[i][j-1][k].y);
      	tr[1][2]=0.5*(grid[i][j+1][k].z-grid[i][j-1][k].z);
      }
      tr[2]=new Vector.<Number>(3,true);
      if(k==0){
      	tr[2][0]=0.5*(-3.0*grid[i][j][0].x+4.0*grid[i][j][1].x
      	      	      -grid[i][j][2].x);
      	tr[2][1]=0.5*(-3.0*grid[i][j][0].y+4.0*grid[i][j][1].y
      	      	      -grid[i][j][2].y);
      	tr[2][2]=0.5*(-3.0*grid[i][j][0].z+4.0*grid[i][j][1].z
      	      	      -grid[i][j][2].z);
      }
      else if(k==nz-1){
      	tr[2][0]=0.5*(grid[i][j][nz-3].x-4.0*grid[i][j][nz-2].x
      	      	      +3.0*grid[i][j][nz-1].x);
      	tr[2][1]=0.5*(grid[i][j][nz-3].y-4.0*grid[i][j][nz-2].y
      	      	      +3.0*grid[i][j][nz-1].y);
      	tr[2][2]=0.5*(grid[i][j][nz-3].z-4.0*grid[i][j][nz-2].z
      	      	      +3.0*grid[i][j][nz-1].z);
      }
      else{
      	tr[2][0]=0.5*(grid[i][j][k+1].x-grid[i][j][k-1].x);
      	tr[2][1]=0.5*(grid[i][j][k+1].y-grid[i][j][k-1].y);
      	tr[2][2]=0.5*(grid[i][j][k+1].z-grid[i][j][k-1].z);
      }
      return new Transform(tr);
    }

//--------------------------------------------------------------------//
// gǓWݒ肷
    protected function setDiffusionCoef():void{
      for(var i:int=1;i<=nx;i++){
      	for(var j:int=1;j<ny;j++){
      	  for(var k:int=1;k<nz;k++){
      	    diffU[i][j][k].set
      	      (diff(transP[i][j][k],transP[i-1][j][k],
      	      	    Transform.create2(trans[i][j+1][k],
      	      	      	      	      trans[i][j+1][k+1]),
      	      	    Transform.create2(trans[i][j][k],trans[i][j][k+1]),
      	      	    Transform.create2(trans[i][j][k+1],
      	      	      	      	      trans[i][j+1][k+1]),
      	      	    Transform.create2(trans[i][j][k],
      	      	      	      	      trans[i][j+1][k])));
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<=ny;j++){
      	  for(k=1;k<nz;k++){
      	    diffV[i][j][k].set
      	      (diff(Transform.create2(trans[i+1][j][k],
      	      	      	      	      trans[i+1][j][k+1]),
      	      	    Transform.create2(trans[i][j][k],trans[i][j][k+1]),
      	      	    transP[i][j][k],transP[i][j-1][k],
      	      	    Transform.create2(trans[i][j][k+1],
      	      	      	      	      trans[i+1][j][k+1]),
      	      	    Transform.create2(trans[i][j][k],
      	      	      	      	      trans[i+1][j][k])));
      	  }
      	}
      	for(j=1;j<ny;j++){
      	  for(k=1;k<=nz;k++){
      	    diffW[i][j][k].set
      	      (diff(Transform.create2(trans[i+1][j][k],
      	      	      	      	      trans[i+1][j+1][k]),
      	      	    Transform.create2(trans[i][j][k],trans[i][j+1][k]),
      	      	    Transform.create2(trans[i][j+1][k],
      	      	      	      	      trans[i+1][j+1][k]),
      	      	    Transform.create2(trans[i][j][k],trans[i+1][j][k]),
      	      	    transP[i][j][k],transP[i][j][k-1]));
      	  }
      	}
      }
      for(i=1;i<nx;i++){
      	for(j=1;j<ny;j++){
      	  for(k=1;k<nz;k++){
      	    diffP[i][j][k].set
      	      (diff(transU[i+1][j][k],transU[i][j][k],transV[i][j+1][k],
      	      	    transV[i][j][k],transW[i][j][k+1],transW[i][j][k]));
      	  }
      	}
      } 
    }

//--------------------------------------------------------------------//
// gUWvZXgԂ
// txp - x+̍Wϊs
// txm - x-̍Wϊs
// typ - y+̍Wϊs
// tym - y-̍Wϊs
// tzp - z+̍Wϊs
//m tzm - z-̍Wϊs
    protected function diff(txp:Transform,txm:Transform,
      	      	      	    typ:Transform,tym:Transform,
      	      	      	    tzp:Transform,tzm:Transform):Array{
      return [[Vector.<Number>([0.0,0.25*(txm.c12()+tym.c12()),0.0]),
      	       Vector.<Number>([0.25*(txm.c31()+tzm.c31()),txm.c11(),
      	      	      	      	-0.25*(txm.c31()+tzp.c31())]),
      	       Vector.<Number>([0.0,-0.25*(txp.c12()+tym.c12()),0.0])],
      	      [Vector.<Number>([0.25*(tym.c23()+tzm.c23()),tym.c22(),
      	      	      	      -0.25*(tym.c23()+tzp.c23())]),
      	       Vector.<Number>([tzm.c33(),
      	      	      	      	txp.c11()+txm.c11()+typ.c22()+tym.c22()
      	      	      	      	+tzp.c33()+tzm.c33(),
      	      	      	      	tzp.c33()]),
      	       Vector.<Number>([-0.25*(typ.c23()+tzm.c23()),typ.c22(),
      	      	      	      	0.25*(typ.c23()+tzp.c23())])],
      	      [Vector.<Number>([0.0,-0.25*(txp.c12()+tym.c12()),0.0]),
      	       Vector.<Number>([-0.25*(txp.c31()+tzm.c31()),txp.c11(),
      	      	      	      	0.25*(txp.c31()+tzp.c31())]),
      	       Vector.<Number>([0.0,0.25*(txp.c12()+typ.c12()),0.0])]];
    }
  }
}
