package{

//--------------------------------------------------------------------//
// Wϊs
  public class Transform{

// RrA
    public var jacob:Number;

// RrA̋t
    protected var jinv:Number;

// d/dx->d/d̕ϊs
    protected var j1:Array;

// d/d->d/dxϊs
    protected var j2:Array;

// W fU
    public var dfuxsi:Number;

// W fV
    public var dfveta:Number;

// W fW
    public var dfwzeta:Number;

//--------------------------------------------------------------------//
// Wϊs\z
// j1 - d/dx->d/d̕ϊs
    public function Transform(j1:Array){
      j2=new Array(3);
      if(j1==null){
      	this.j1=new Array(3);
      	for(var i:int=0;i<3;i++){
      	  this.j1[i]=new Vector.<Number>(3,true);
      	  j2[i]=new Vector.<Number>(3,true);
      	}
      }
      else{
      	this.j1=j1;
      	for(i=0;i<3;i++){
      	  j2[i]=new Vector.<Number>(3,true);
      	}
      	j2[0][0]=j1[1][1]*j1[2][2]-j1[1][2]*j1[2][1];
      	j2[0][1]=j1[2][1]*j1[0][2]-j1[2][2]*j1[0][1];
      	j2[0][2]=j1[0][1]*j1[1][2]-j1[0][2]*j1[1][1];
      	j2[1][0]=j1[1][2]*j1[2][0]-j1[1][0]*j1[2][2];
      	j2[1][1]=j1[2][2]*j1[0][0]-j1[2][0]*j1[0][2];
      	j2[1][2]=j1[0][2]*j1[1][0]-j1[0][0]*j1[1][2];
      	j2[2][0]=j1[1][0]*j1[2][1]-j1[1][1]*j1[2][0];
      	j2[2][1]=j1[2][0]*j1[0][1]-j1[2][1]*j1[0][0];
      	j2[2][2]=j1[0][0]*j1[1][1]-j1[0][1]*j1[1][0];
      	jacob=j1[0][0]*j2[0][0]+j1[0][1]*j2[1][0]+j1[0][2]*j2[2][0];
      	jinv=1.0/jacob;
      	for(i=0;i<3;i++){
      	  for(var j:int=0;j<3;j++){
      	    j2[i][j]*=jinv;
      	  }
      	}
      	dfuxsi=-jacob*jacob*(j2[0][0]*j2[0][0]+j2[1][0]*j2[1][0]
      	      	      	    +j2[2][0]*j2[2][0]);
      	dfveta=-jacob*jacob*(j2[0][1]*j2[0][1]+j2[1][1]*j2[1][1]
      	      	      	    +j2[2][1]*j2[2][1]);
      	dfwzeta=-jacob*jacob*(j2[0][2]*j2[0][2]+j2[1][2]*j2[1][2]
      	      	      	     +j2[2][2]*j2[2][2]);
      }
    }

//--------------------------------------------------------------------//
// WϊsԂ
// tr1 - QƂWϊs
// tr2 - QƂWϊs
    public static function create2(tr1:Transform,
      	      	      	      	   tr2:Transform):Transform{
      var tr:Transform=new Transform(null);
      tr.jacob=0.5*(tr1.jacob+tr2.jacob);
      tr.jinv=1.0/tr.jacob;
      for(var i:int=0;i<3;i++){
      	for(var j:int=0;j<3;j++){
      	  tr.j1[i][j]=0.5*(tr1.j1[i][j]+tr2.j1[i][j]);
      	  tr.j2[i][j]=0.5*(tr1.j2[i][j]+tr2.j2[i][j]);
      	}
      }
      tr.dfuxsi=0.5*(tr1.dfuxsi+tr2.dfuxsi);
      tr.dfveta=0.5*(tr1.dfveta+tr2.dfveta);
      tr.dfwzeta=0.5*(tr1.dfwzeta+tr2.dfwzeta);
      return tr;
    }

//--------------------------------------------------------------------//
// WϊsԂ
// tr1 - QƂWϊs
// tr2 - QƂWϊs
// tr3 - QƂWϊs
// tr4 - QƂWϊs
    public static function create4(tr1:Transform,
      	      	      	      	   tr2:Transform,
      	      	      	      	   tr3:Transform,
      	      	      	      	   tr4:Transform):Transform{
      var tr:Transform=new Transform(null);
      tr.jacob=0.25*(tr1.jacob+tr2.jacob+tr3.jacob+tr4.jacob);
      tr.jinv=1.0/tr.jacob;
      for(var i:int=0;i<3;i++){
      	for(var j:int=0;j<3;j++){
      	  tr.j1[i][j]=0.25*(tr1.j1[i][j]+tr2.j1[i][j]+tr3.j1[i][j]
      	      	      	   +tr4.j1[i][j]);
      	  tr.j2[i][j]=0.25*(tr1.j2[i][j]+tr2.j2[i][j]+tr3.j2[i][j]
      	      	      	   +tr4.j2[i][j]);
      	}
      }
      tr.dfuxsi=0.25*(tr1.dfuxsi+tr2.dfuxsi+tr3.dfuxsi+tr4.dfuxsi);
      tr.dfveta=0.25*(tr1.dfveta+tr2.dfveta+tr3.dfveta+tr4.dfveta);
      tr.dfwzeta=0.25*(tr1.dfwzeta+tr2.dfwzeta+tr3.dfwzeta+tr4.dfwzeta);
      return tr;
    }

//--------------------------------------------------------------------//
// gUW c11 Ԃ
    public function c11():Number{
      return jacob*(j2[0][0]*j2[0][0]+j2[1][0]*j2[1][0]
      	      	   +j2[2][0]*j2[2][0]);
    }

//--------------------------------------------------------------------//
// gUW c22 Ԃ
    public function c22():Number{
      return jacob*(j2[0][1]*j2[0][1]+j2[1][1]*j2[1][1]
      	      	   +j2[2][1]*j2[2][1]);
    }

//--------------------------------------------------------------------//
// gUW c33 Ԃ
    public function c33():Number{
      return jacob*(j2[0][2]*j2[0][2]+j2[1][2]*j2[1][2]
      	      	   +j2[2][2]*j2[2][2]);
    }

//--------------------------------------------------------------------//
// gUW c12 Ԃ
    public function c12():Number{
      return jacob*(j2[0][0]*j2[0][1]+j2[1][0]*j2[1][1]
      	      	   +j2[2][0]*j2[2][1]);
    }

//--------------------------------------------------------------------//
// gUW c23 Ԃ
    public function c23():Number{
      return jacob*(j2[0][1]*j2[0][2]+j2[1][1]*j2[1][2]
      	      	   +j2[2][1]*j2[2][2]);
    }

//--------------------------------------------------------------------//
// gUW c31 Ԃ
    public function c31():Number{
      return jacob*(j2[0][2]*j2[0][0]+j2[1][2]*j2[1][0]
      	      	   +j2[2][2]*j2[2][0]);
    }

//--------------------------------------------------------------------//
// ϑx̃̐ݒ肷
// u - xx
// v - xy
// w - xz
    public function contraVx(u:Number,v:Number,w:Number):Number{
      return jacob*(j2[0][0]*u+j2[1][0]*v+j2[2][0]*w);
    }

//--------------------------------------------------------------------//
// ϑx̃Őݒ肷
// u - xx
// v - xy
// w - xz
    public function contraVy(u:Number,v:Number,w:Number):Number{
      return jacob*(j2[0][1]*u+j2[1][1]*v+j2[2][1]*w);
    }

//--------------------------------------------------------------------//
// ϑx̃Đݒ肷
// u - xx
// v - xy
// w - xz
    public function contraVz(u:Number,v:Number,w:Number):Number{
      return jacob*(j2[0][2]*u+j2[1][2]*v+j2[2][2]*w);
    }

//--------------------------------------------------------------------//
// xxݒ肷
// u - xx
// v - xy
// w - xz
    public function vx(u:Number,v:Number,w:Number):Number{
      return jinv*(j1[0][0]*u+j1[1][0]*v+j1[2][0]*w);
    }

//--------------------------------------------------------------------//
// xyݒ肷
// u - xx
// v - xy
// w - xz
    public function vy(u:Number,v:Number,w:Number):Number{
      return jinv*(j1[0][1]*u+j1[1][1]*v+j1[2][1]*w);
    }

//--------------------------------------------------------------------//
// xzݒ肷
// u - xx
// v - xy
// w - xz
    public function vz(u:Number,v:Number,w:Number):Number{
      return jinv*(j1[0][2]*u+j1[1][2]*v+j1[2][2]*w);
    }

//--------------------------------------------------------------------//
//  dp/dx ݒ肷
// pxsi -  dp/d
// peta -  dp/d
// pzeta -  dp/d
    public function dpdx(pxsi:Number,peta:Number,pzeta:Number):Number{
      return jacob*(j2[0][0]*pxsi+j2[0][1]*peta+j2[0][2]*pzeta);
    }

//--------------------------------------------------------------------//
//  dp/dy ݒ肷
// pxsi -  dp/d
// peta -  dp/d
// pzeta -  dp/d
    public function dpdy(pxsi:Number,peta:Number,pzeta:Number):Number{
      return jacob*(j2[1][0]*pxsi+j2[1][1]*peta+j2[1][2]*pzeta);
    }

//--------------------------------------------------------------------//
//  dp/dz ݒ肷
// pxsi -  dp/d
// peta -  dp/d
// pzeta -  dp/d
    public function dpdz(pxsi:Number,peta:Number,pzeta:Number):Number{
      return jacob*(j2[2][0]*pxsi+j2[2][1]*peta+j2[2][2]*pzeta);
    }
  }
}
